#include <stdio.h>
#include <unistd.h>
#include <conio.h>
#include <string.h>
#include <sys/mman.h>
#include <pthread.h>
#include <math.h>
#include "d2kdask.h"

///////////////////////////////////////////////////////////////////////////////

I16 AO_buf[8192];
U32 data_size = 8000;
U16 Status;

int main( void )
{
   I16 card = -1, err, i;
   int card_num;
   U32 count;
   U16 DaId;
   BOOLEAN bStopped;

   setbuf( stdout, NULL );
   clrscr();
   
   printf("This program outputs data from AO CH-0 of DAQ-2205 in %d Hz.\nThe size of buffer is %ld. The iteration is 10.\n\nPress any key to start the operation.\n",
           100000, data_size);
   printf("Please input a card number: ");
   scanf(" %d", &card_num);
   if((card = D2K_Register_Card(DAQ_2205, (I16)card_num))<0) {
	 printf("Error %d trying to open daq2205\n", card);
	 return -1;
   }
   for(i=0; i<8192; i++)
	AO_buf[i]=(I16)(sin((double)i/512*M_PI)*0x7ff)+0x800;

   D2K_AO_CH_Config (card, 0, DAQ2K_DA_BiPolar, DAQ2K_DA_Int_REF, 10.0);
   D2K_AO_Config (card, 0, 0, 0, 0, 0, 1);
   D2K_AO_ContBufferSetup (card, AO_buf, data_size, &DaId);

   err = D2K_AO_ContWriteChannel (card, 0, DaId, data_size, 10, 400, 400, ASYNCH_OP);
   do {
	D2K_AO_AsyncCheck(card, &bStopped, &count);
   } while (!bStopped);

   D2K_AO_AsyncClear(card, &count,0);

   D2K_Release_Card(card);

   return 0;
}
