#include <stdio.h>
#include "conio.h"
#include "d2kdask.h"

float value;
int main( void )
{
   I16 card = -1, err, i;
   int card_num;
   float offset_err=0.0;
   float gain_err, bioffset_err, unioffset_err, hg_bios_err;
//   I16 answer;

   clrscr();
   setbuf( stdout, NULL );
   printf("This program performs AD and DA auto-calibration\n");
   printf("Please input a card number: ");
   scanf(" %d", &card_num);
   if ((card=D2K_Register_Card (DAQ_2205, (I16)card_num)) <0 ) {
        printf("Register_Card error=%d\n", card);
        return -1;
   }

   printf("Press any key to start auto calibration ...");
   getch();
   printf("\nIt will take few minutes to finish ...");
   err= D2K_DB_Auto_Calibration_ALL(card);
   if(err != NoError)
	printf("\nAuto Calibration Failed %d.\n", err);
   else 
	printf("\nAuto Calibration Finished. \n");
	
   printf("=========================================\n");
   DAQ2205_Acquire_AD_Error(0, &gain_err, &bioffset_err, &unioffset_err, &hg_bios_err);
   printf("AD Calibration Data : \n" );
   printf("------------------------------------------\n");
   printf("AD Gain error: %4.4f\n", gain_err);
   printf("Bipolar Offset error: %4.4f\n", bioffset_err);
   printf("Unipolar Offset error : %4.4f\n", unioffset_err);
   printf("Hign Gain bipolar Offset error: %4.4f\n", hg_bios_err);
   printf("------------------------------------------\n");
   printf("\nDA Calibration Data : \n" );
   printf("------------------------------------------\n");

   for(i=0; i<2; i++) {
	DAQ2205_Acquire_DA_Error(0, i%2, 0, &offset_err, &gain_err);
	printf("DA %d Unipolar Dain: Gain: %4.4f\n", i, gain_err);
	printf("DA %d Unipolar Offset: Off: %4.4f\n", i, offset_err);
   }

   for(i=0; i<2; i++) {
	DAQ2205_Acquire_DA_Error(0, i%2, 1, &offset_err, &gain_err);
	printf("DA %d Bipolar Dain: Gain: %4.4f\n", i, gain_err);
	printf("DA %d Bipolar Offset: Off: %4.4f\n", i, offset_err);
   }

/*
   printf("------------------------------------------\n");
   printf("Save the calibration constants into EEPROM on board : ");
   printf("Yes(1) or No(0)?");
   scanf(" %d", &answer);
   if(answer)
	err = D2K_EEPROM_CAL_Constant_Update(card, 0);
*/
   if(card>=0)
	D2K_Release_Card(card);

   return 0;
}
