/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                         ;;
;;      File Name  :   2010Dio.C                                          ;;
;;      Purpose    :   This PCI-DASK sample program demonstrate how to    ;;
;;                     operate  DI & DO	for DAQ-2010		          ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "d2kdask.h"
#include "conio.h"

int main( void )
{
	I16 card=-1;
	int card_number = 0;
	U32 outputA ,inputB ,outputC ,inputD;

	setbuf( stdout, NULL );
	clrscr();

	printf(" ******************************************************\n" );
	printf(" DAQ2205 DIO sample:\n" );
	printf(" Connect Port A to Port B , Port C_Low to Port C_High \n" );
	printf(" *******************************************************\n\n" );
    	printf("Please input a card number: ");
    	scanf(" %i", &card_number);

	if ((card=D2K_Register_Card(DAQ_2205, (I16)card_number)) < 0) {
		printf("D2K_Register_Card Error = %d\n", card);
		return -1;
	}

	D2K_DIO_PortConfig( card, Channel_P1A, OUTPUT_PORT );
	D2K_DIO_PortConfig( card, Channel_P1B, INPUT_PORT);
	D2K_DIO_PortConfig( card, Channel_P1CL, OUTPUT_PORT);
	D2K_DIO_PortConfig( card, Channel_P1CH, INPUT_PORT);


	printf("\n              press any key to terminate program .....\n\n");
	printf(" Port A      Port B      Port CL      Port CH \n" );   
	printf(" -------------------------------------------- \n\n" );   
	outputA = 0; outputC = 0;
	do{
		D2K_DO_WritePort( card, Channel_P1A, outputA );
		D2K_DO_WritePort( card, Channel_P1CL, outputC );
		usleep(1000);
		D2K_DI_ReadPort( card, Channel_P1B, &inputB );
		D2K_DI_ReadPort( card, Channel_P1CH, &inputD );
		printf("\r %06lx       %06lx       %06lx        %06lx  ", outputA, inputB, outputC, inputD );   
		outputA ++;
		outputA = outputA & 0x0FF;
		outputC = outputA & 0x0F;
                                        
	}while( !kb_hit() );

	D2K_Release_Card(card); 
	putchar('\n');
	return 0;
}


