#include <stdio.h>
#include <unistd.h>
#include "conio.h"
#include "d2kdask.h"

#define GP0_value 40000

U32 start_count, current_count;
F64 take_msec;
char buf[50];
int main(void)
{
	I16 card = -1, err;
	U32 pValue = 0, oldVal;
	U16 times = 0, status;

	if ((card=D2K_Register_Card (DAQ_2205, 0)) <0 ) {
            printf("Register_Card error=%d\n", card);
            return -1;
	}

	clrscr();
	setbuf( stdout, NULL );
	printf(" Begin of SimpleGatedEventCNT for GPTC#0 \n" ); 
	printf(" Connect the Trigger Signal to GPTC0_GATE ( Pin-14 )\n");
	printf(" Press any key to end SimpleGatedEventCNT testing\n" );

/* Procedure of SimpleGatedEventCNT Testing */ 
	err = D2K_GCTR_Reset(card, 0);
        err = D2K_GCTR_Setup (card, 0, SimpleGatedEventCNT, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_INT|D2K_GPTC_UPDOWN_SEL_INT, 0, 0x1000, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);

	do{
	    err = D2K_GCTR_Read (card, 0, &pValue );
	    printf("\r err:%d  Counter: %08ld", err, pValue );
	}while( !kb_hit() );

	clrscr(); 

/* Procedure of SimpleGatedPulseGen Testing */ 
	printf("\n Begin of SimpleGatedPulseGen for GPTC#0\n" ); 
	printf(" Connect the Trigger Signal to GPTC0_GATE ( Pin-14 )\n");
	printf(" Press any key to end SimpleGatedPulseGen testing\n" );

	D2K_GCTR_Reset(card, 0);
        err = D2K_GCTR_Setup ( card, 0, SingleGatedPulseGen, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_INT|D2K_GPTC_UPDOWN_SEL_INT, 0, 0xFFFF, 0xFFFF );
	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntGATE, 0);

	printf(" Check the GPTC#0 status and press any key to continue \n" );
	getch();
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 0);
	clrscr();

/* Procedure of SimpleTrigPulseGen Testing */ 
	printf("\n Begin of SimpleTrigPulseGen for GPTC#0\n" ); 
	printf(" Connect the Trigger Signal to GPTC0_GATE ( Pin-14 )\n");
	printf(" Press any key to end SimpleTrigPulseGen testing\n" );

	D2K_GCTR_Reset(card, 0);
        err = D2K_GCTR_Setup ( card, 0, SingleTrigPulseGen, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_INT|D2K_GPTC_UPDOWN_SEL_INT, 0, 0xFFFF, 0xFFFF );
	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntGATE, 0);

	printf(" Check the GPTC#0 status and press any key to continue \n" );
	getch();
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 0);
	clrscr();

/* Procedure of SinglePeriodMSR Testing */ 
	printf("\n Begin of SinglePeriodMSR for GPTC#0\n" ); 
	printf(" Connect the Measured Signal to GPTC0_GATE ( Pin-14 )\n");
	printf(" Press any key to continue\n" ); getch();

	D2K_GCTR_Reset(card, 0);
        err = D2K_GCTR_Setup (card, 0, SinglePeriodMSR, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_INT|D2K_GPTC_UPDOWN_SEL_INT, 0, 0, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);
	D2K_GCTR_Read (card, 0, &pValue);
	oldVal = pValue;
	times = 0;

	do {
		D2K_GCTR_Read (card, 0, &pValue);
		if( oldVal > pValue ) times ++;
		oldVal = pValue;
		D2K_GCTR_Status (card, 0, &status);
	} while (!(status & 0x08));

	D2K_GCTR_Read (card, 0, &pValue);
	printf("\n\n value = %ld\n", times*65536 + pValue);
	printf(" End of SinglePulseWidthMSR, please any key to continue\n" ); 
	getch();
	clrscr();

/* Procedure of SinglePulsWidthMSR Testing */ 
	printf("\n Begin of SinglePulseWidthMSR for GPTC#0 \n" ); 
	printf(" Connect the Measured Signal to GPTC0_GATE ( Pin-14 )\n");
	printf(" Press any key to continue\n" ); getch();

        err = D2K_GCTR_Setup (card, 0, SinglePulseWidthMSR, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_INT|D2K_GPTC_UPDOWN_SEL_INT, 0, 0, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);

	D2K_GCTR_Read (card, 0, &pValue);
	oldVal= pValue;
	times = 0;
	do {
		D2K_GCTR_Read (card, 0, &pValue);
		if( oldVal > pValue ) times ++;
		oldVal = pValue;
		D2K_GCTR_Status (card, 0, &status);
	} while (!(status & 0x08));

	D2K_GCTR_Read (card, 0, &pValue);
	printf(" value = %ld\n", times*65536 + pValue);
	printf(" End of SinglePulseWidthMSR, please any key to continue\n" ); 
	getch();
	clrscr();

/* Procedure of RetrigSimplePulseGen Testing */ 
	printf("\n Begin of RetrigSimplePulseGen for GPTC#0\n" ); 
	printf(" Connect the Periodic Trigger Signal to GPTC0_GATE ( Pin-14 )\n");
	printf(" Press any key to end RetrigSimplePulseGen testing\n" );

	D2K_GCTR_Reset(card, 0);
	err = D2K_GCTR_Setup ( card, 0, RetrigSinglePulseGen, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_INT|D2K_GPTC_UPDOWN_SEL_INT, 0, 0xFFFF, 0xFFFF );

	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntGATE, 0);

	printf(" Check the GPTC#0 status and press any key to continue \n" );
	getch();
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 0);
	clrscr();

/* Procedure of SingleTrigContPulseGen Testing */ 
	printf("\n Begin of SingleTrigContPulseGen for GPTC#0\n" ); 
	printf(" Connect the Trigger Signal to GPTC0_GATE ( Pin-14 )\n");
	printf(" and External Clock to GPTC0_SRC ( Pin-13 )\n" );
	printf(" Press any key to end SingleTrigContPulseGen testing\n" );

	D2K_GCTR_Reset(card, 0);
	err = D2K_GCTR_Setup ( card, 0, SingleTrigContPulseGen, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_EXT|D2K_GPTC_UPDOWN_SEL_INT, 0, 2, 2 );

	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntGATE, 0);

	printf(" Check the GPTC#0 status and press any key to continue \n" );
	getch();
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 0);
	clrscr();

/* Procedure of ContGatedPulseGen Testing */ 
	printf("\n Begin of ContGatedPulseGen for GPTC#0\n" ); 
	printf(" Connect the Trigger Signal to GPTC0_GATE ( Pin-14 )\n");
	printf(" and External Clock to GPTC0_SRC ( Pin-13 )\n" );
	printf(" Press any key to end ContGatedPulseGen testing\n" );

	D2K_GCTR_Reset(card, 0);
	err = D2K_GCTR_Setup ( card, 0, ContGatedPulseGen, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_EXT|D2K_GPTC_UPDOWN_SEL_INT, 0, 2, 2 );
	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntGATE, 0);

	printf(" Check the GPTC#0 status and press any key to EXIT \n" );
	getch();
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 0);

	if(card>=0)
		D2K_Release_Card(card);

	return 0;
}

