/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                        ;;
;;      File Name  :   2205poll.c                                         ;;
;;      Purpose    :   This PCI-DASK sample program demonstrate how to    ;;
;;                     operate  polling AI & AO	for DAQ-2010	          ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "d2kdask.h"
#include "conio.h"

#define chcnt 	4
int main( void )
{
	I16 card=-1;
	int card_number = 0;
	I16 outVal[2], inVal[4] = {0, 0, 0, 0}, temp_val;
	U16 chans[chcnt] = {0, 1, 2, 3}; 
	I16 range = AD_B_10_V;
	F32 ratio = 10.0/32768.0;

	setbuf( stdout, NULL );
	clrscr();

	printf(" ******************************************************\n" );
	printf(" DAQ2205 AI/AO polling sample:\n" );
	printf(" *******************************************************\n\n" );
    	printf("Please input a card number: ");
    	scanf(" %i", &card_number);

	if ((card=D2K_Register_Card(DAQ_2205, (I16)card_number)) < 0) {
		printf("D2K_Register_Card Error = %d\n", card);
		return -1;
	}

	outVal[0] = 0x400; outVal[1] = 0xC00; 
  	D2K_AI_CH_Config(card, All_Channels, range|AI_RSE);
  	D2K_AO_CH_Config(card, All_Channels, DAQ2K_DA_BiPolar, DAQ2K_DA_Int_REF, (F64)10);

	printf("\n              press any key to terminate program .....\n\n");
	printf("  CH-1        Ch-2        CH-3        CH-4    \n" );   
	printf(" -------------------------------------------- \n\n" );   
	do{
		temp_val = outVal[0]; 
		outVal[0] = outVal[1]; outVal[1] = temp_val;

		D2K_AO_SimuWriteChannel (card, 2, outVal);
           	D2K_AI_SimuReadChannel(card, chcnt, chans, inVal);
		printf("\r %4.2f       %4.2f       %4.2f        %4.2f  ", (F32)((inVal[0])*ratio), (F32)((inVal[1])*ratio), (F32)((inVal[2])*ratio), (F32)((inVal[3])*ratio) );
		//printf("\r %06d       %06d       %06d        %06d  ", (I16)((inVal[0])*ratio), (I16)((inVal[1])*ratio), (I16)((inVal[2])*ratio), (I16)((inVal[3])*ratio) );   
		usleep(50000);
                                        
	}while( !kb_hit() );

	D2K_Release_Card(card); 
	putchar('\n');
	return 0;
}


