
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <sys/mman.h>
#include "d2kdask.h"

U16 channel=3;  //4 channels
U16 range=AD_B_10_V;
char *file_name="2206d";
U32 read_count=4000;
I16 adinput;
short ai_buf[4000];

int main( void )
{
    I16 card, err, i, Id;
    int card_num;

    clrscr();
    setbuf( stdout, NULL );
    printf("This program inputs %ld data from CH-0 to CH-%d of DAQ-2206 in %d Hz, and\nstore data to file '%s.dat'.\nPlease press any key to start the operation.\n", read_count, channel, (int)125000, file_name);
    printf("Please input a card number: ");
    scanf(" %d", &card_num );
    //getch();

    if ((card=D2K_Register_Card (DAQ_2206, (I16)card_num)) <0 ) {
        printf("Register_Card error=%d", card);
        return -1;
    }

    for(i=0; i<4; i++)
	D2K_AI_CH_Config (card, i, range|AI_RSE);

    D2K_AI_Config (card, 0, 0, 0, 0, 0, 1);

    err=D2K_AI_ContBufferSetup (card, ai_buf, 4000, &Id);
    if (err!=0) {
       printf("AI_ContBufferSetup error=%d", err);
       D2K_Release_Card( card );
       return -2;
    }

    err = D2K_AI_ContScanChannelsToFile(card, channel, Id, file_name, read_count/(channel+1), 160*(channel+1), 160, SYNCH_OP);

    if (err!=0) {
       printf("AI_ContScanChannels error=%d", err);
       D2K_Release_Card( card );
       return -3;
    }

    D2K_Release_Card(card);
    printf("\n\nThe input data is already stored in file '%s.dat'.\n", file_name);
    printf("\nPress any key to exit the program. "); getch();
    putchar('\n');
    return 0;
}
