
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <sys/mman.h>
#include "d2kdask.h"

I32 samp_intrv=100;
U16 channel=0;
U16 range=AD_B_10_V;
char *file_name="2206d.txt";
U32 data_size = 2048;
U32 count, trgCount = 2;
F32 ratio = 10.0/32768.0;
BOOLEAN fstop =0;
I16 adinput;
short ai_buf[4096]; // trgCount * data_size */
FILE* fp;

void write_buffer_to_file( void );

int main( void )
{
    I16 card, err, Id;
    int card_num;
    U32 startPos;

    clrscr();
    setbuf( stdout, NULL );
    memset( ai_buf, '\0', trgCount*data_size*sizeof(short) );
    if( (fp = fopen( file_name, "w+b" ) ) == NULL )
	return -10;

    fprintf( fp, " DAQ-2206 Single Buffered with Delay Re-Trigger Mode\n\n\n");
    fprintf( fp, "CH0   \n======================\n");


    printf("DAQ-2206 Single Buffered DMA with Delay Re-Trigger Mode\n");
    printf("----------------------------------------------------\n");
    printf("Please input a card number: ");
    scanf(" %d", &card_num );
    //getch();

    if ((card=D2K_Register_Card (DAQ_2206, (I16)card_num)) <0 ) {
        printf("Register_Card error=%d", card);
        return -1;
    }

    err = D2K_AI_CH_Config (card, channel, range);
    if (err!=0) {
       printf("D2K_AI_CH_Config error=%d", err);
       return -2;
    }

    err = D2K_AI_Config (card, 0, DAQ2K_AI_TRGSRC_ExtD | DAQ2K_AI_TRGMOD_DELAY|DAQ2K_AI_TrgPositive| DAQ2K_AI_Dly1InSamples|DAQ2K_AI_ReTrigEn, 65535, 0, trgCount , 1 );
    if (err!=0) {
       printf("D2K_AI_Config error=%d", err);
       return -2;
    }

    err = D2K_AI_ContBufferSetup (card, ai_buf, trgCount*data_size, &Id);
    if (err!=0) {
       printf("AI_ContBufferSetup error=%d", err);
       return -2;
    }

    err = D2K_AI_ContScanChannels (card, channel, Id, trgCount*data_size/(channel+1), samp_intrv*(channel+1), samp_intrv, ASYNCH_OP);
    if (err!=0) {
       printf("AI_ContScanChannels error=%d", err);
       return -3;
    }

    fstop = 0;
    while (!fstop) {
	D2K_AI_AsyncCheck(card, &fstop, &count);
    }
    D2K_AI_AsyncClear(card, &startPos, &count);

    write_buffer_to_file();

    D2K_Release_Card(card);
    fclose( fp );
    printf("\n\nThe input data is already stored in file '%s'.\n", file_name);
    printf("\nPress ENTER to exit the program. "); getch();
    putchar('\n');
    return 0;
}


void write_buffer_to_file( void )
{
  I16 adinput[4];
  char s[50], temp_s[10];
  U32 i;
  int j;
  int chan_no = channel +1;

	
  for(i=0; i< trgCount*data_size; i+=chan_no){
	memset( adinput, 0xff, 4*sizeof(U16) );
	for( j = 0; j < chan_no; j++ ){
        	adinput[j] = ((I16*)ai_buf)[i+j];
    	}
    	s[0] = 0x00;
    	for( j = 0; j < chan_no; j++ ){
      		sprintf( temp_s, "%4.4f  ", (F32)(adinput[j]*ratio) );
      		//sprintf( temp_s, "%04x  ", adinput[j] );
      		strcat( s, temp_s );
    }
    strcat(s, "\n");
    fwrite(s, sizeof(U8), strlen(s), fp);
  }

}




