
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <sys/mman.h>
#include "d2kdask.h"

I32 samp_intrv=100;
U16 channel=0, range = AD_B_10_V, ch_cnt=1;
char *file_name="2206d.txt";
U32 data_size = 4096;
U32 count;
F32 ratio = 10.0/32768.0;
BOOLEAN fstop =0;
I16 adinput;
short ai_buf[4096]; // trgCount * data_size */
FILE* fp;

void write_buffer_to_file( void );

int main( void )
{
    I16 card, err, Id;
    int card_num;
    U32 startPos;

    if( (fp = fopen( file_name, "w+b" ) ) == NULL )
	return -10;

    fprintf( fp, " ContScanChannels with Double Buffer Transfer \n\n\n");
    fprintf( fp, "CH0   CH1   CH2   CH3 \n======================\n");


    printf("DAQ-2206 SSI Source\n");
    printf("----------------------------------------------------\n");
    printf("Please input a card number: ");
    scanf(" %d", &card_num );
    //getch();

    if ((card=D2K_Register_Card (DAQ_2206, (I16)card_num)) <0 ) {
        printf("Register_Card error=%d", card);
        return -1;
    }

    ch_cnt = channel + 1;
    err = D2K_AI_CH_Config (card, channel, range);
    if (err!=0) {
       printf("D2K_AI_CH_Config error=%d", err);
       D2K_Release_Card( card );
       return -2;
    }
    err = D2K_AI_Config (card, 0, DAQ2K_AI_TRGSRC_ExtD|DAQ2K_AI_TRGMOD_POST|DAQ2K_AI_TrgPositive, 0, 0, 0, 1);
    if (err!=0) {
       printf("D2K_AI_Config error=%d", err);
       D2K_Release_Card( card );
       return -2;
    }

    err = D2K_SSI_SourceConn (card, SSI_ADTRIG);
    if (err!=0) {
       printf("D2K_SSI_SourceConn error=%d", err);
       D2K_Release_Card( card );
       return -2;
    }

    err = D2K_AI_AsyncDblBufferMode (card, 0);
    if (err!=0) {
       printf("D2K_AI_AsyncDblBufferMode error=%d", err);
       D2K_Release_Card( card );
       return -2;
    }

    err = D2K_AI_ContBufferSetup (card, ai_buf, data_size, &Id);
    if (err!=0) {
       printf("AI_ContBufferSetup error=%d", err);
       D2K_Release_Card( card );
       return -2;
    }

    err = D2K_AI_ContReadChannel (card, channel, Id, data_size, samp_intrv, samp_intrv, ASYNCH_OP);
    if (err!=0) {
       printf("AI_ContScanChannels error=%d", err);
       D2K_Release_Card( card );
       return -3;
    }

    fstop = 0;
    while (!fstop) {
	D2K_AI_AsyncCheck(card, &fstop, &count);
    }
    D2K_AI_AsyncClear(card, &startPos, &count);

    write_buffer_to_file();

    D2K_Release_Card(card);
    fclose( fp );
    printf("\n\nThe input data is already stored in file '%s.dat'.\n", file_name);
    printf("\nPress ENTER to exit the program. "); getch();
    putchar('\n');
    return 0;
}


void write_buffer_to_file( void )
{
  I16 adinput[4];
  char s[50], temp_s[10];
  U32 i;
  int j;
  int chan_no = channel +1;

	
  for(i=0; i< data_size; i+=chan_no){
	memset( adinput, 0xff, 4*sizeof(U16) );
	for( j = 0; j < chan_no; j++ ){
        	adinput[j] = ((I16*)ai_buf)[i+j];
    	}
    	s[0] = 0x00;
    	for( j = 0; j < chan_no; j++ ){
      		sprintf( temp_s, "%4.4f  ", (F32)(adinput[j]*ratio) );
      		//sprintf( temp_s, "%04x  ", adinput[j] );
      		strcat( s, temp_s );
    }
    strcat(s, "\n");
    fwrite(s, sizeof(U8), strlen(s), fp);
  }

}




