#include <stdio.h>
#include <unistd.h>
#include <conio.h>
#include <string.h>
#include <sys/mman.h>
#include <pthread.h>
#include <math.h>
#include "d2kdask.h"


U16 channel=0;
U32 out_count=4096;
U32 samp_intrv = 4000;
short pattern1[4096];
short pattern2[4096];
short ao_buf[4096];
short ao_buf2[4096];

int main( void )
{
    I16 card, err, i, Id, j;
    BOOLEAN halfReady;
    U32 count=0, count1;
    int card_num;

    clrscr();
    setbuf( stdout, NULL );
    printf("This program outputs data from DA%dOUT of DAQ-2206 by double-buffer mode.\n\n", channel );

    printf("Please input a card number: ");
    scanf(" %d", &card_num);

    if ((card=D2K_Register_Card (DAQ_2206, (I16)card_num)) <0 ) {
        printf("Register_Card error=%d\n", card);
        return -9;
    }

    for (i=0;i<out_count;i++) 
	pattern1[i] = (I16)(sin((double)i/512.0*M_PI)*0x7ff)+0x800;

    for (i=0;i<out_count;i++) {
	if(i<2048)
	    pattern2[i] = (0x800+i%2048) & 0xfff;
	else 
	    pattern2[i] = (0x800+2047-(i%2048)) & 0xfff;
    }	

    memcpy(ao_buf, pattern1, out_count*2);
    memcpy(ao_buf2, pattern1, out_count*2);
    //memcpy(ao_buf2, pattern2, out_count*2);

    err = D2K_AO_CH_Config (card, channel, DAQ2K_DA_BiPolar, DAQ2K_DA_Int_REF, 10.0);
    if (err!=0) {
       printf("D2K_AO_CH_Config error=%d", err);
       D2K_Release_Card(card);
       return -1;
    }
    err = D2K_AO_Config (card, 0, DAQ2K_DA_TRGMOD_POST, 0, 0, 0,1);
    if (err!=0) {
       printf("D2K_AO_Config error=%d", err);
       D2K_Release_Card(card);
       return -2;
    }

    err = D2K_AO_AsyncDblBufferMode (card, 1);
    if (err!=0) {
       printf("DAQ2K_AO_DblBufferMode error=%d", err);
       D2K_Release_Card(card);
       return -3;
    }

    err = D2K_AO_ContBufferSetup (card, ao_buf, out_count, &Id);
    if (err!=0) {
       printf("D2K_AO_ContBufferSetup error=%d for the 1st buffer", err);
       D2K_Release_Card(card);
       return -4;
    }

    err = D2K_AO_ContBufferSetup (card, ao_buf2, out_count, &Id);
    if (err!=0) {
       printf("D2K_AO_ContBufferSetup error=%d for the 2nd buffer", err);
       D2K_Release_Card(card);
       return -4;
    }

    err = D2K_AO_ContWriteChannel (card, channel, Id, out_count, 0, samp_intrv, samp_intrv, ASYNCH_OP);
    if (err!=0) {
       D2K_Release_Card(card);
       printf("D2K_AO_ContWriteChannel error=%d", err);
       return -5;
    }
    j=0;
    printf("\n\nPress any key to stop input operation.");
    printf("\n\nData count : \n");

    do {
        do {
             D2K_AO_AsyncDblBufferHalfReady(card, &halfReady);
        } while (!halfReady);
	    //D2K_AI_AsyncDblBufferToFile(card);
		if(!(j%4))
			memcpy(ao_buf, pattern2, out_count*2);
		else if((j%4)==1)
			memcpy(ao_buf2, pattern2, out_count*2);
		else if((j%4)==2)
			memcpy(ao_buf, pattern1, out_count*2);
		else
			memcpy(ao_buf2, pattern1, out_count*2);
        count += (out_count);
        printf("%ld\r", count);
	j++;
    } while(!kb_hit());

    D2K_AO_AsyncClear(card, &count1, 0);
    count += (count1);

    D2K_Release_Card(card);
    printf("\nPress any key to exit the program. "); getch();

    putchar('\n');
    return 0;
}
