#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <pthread.h>
#include <sys/mman.h>
#include <conio.h>
#include "d2kdask.h"

U16 channel = 0;
U16 range = AD_B_10_V;
char file_name[10] = "2206d.txt";
U32 read_count = 4000;
U32 samp_intrv = 8000;
unsigned short ai_buf[8000];
unsigned short ai_buf2[8000];
pthread_t pthread;
BOOLEAN clear_op;
I16 card;
U32 count = 0, postCount = 2000;
F32 ratio = 10.0/32768.0;
FILE* fp;

void write_buffer_to_file( void );

void * ProcessThread( void * temp_pt )
{
    BOOLEAN halfReady, fStop;
    U32 count1, startPos;
    I16 err;

    fprintf( fp, " DAQ-2206 Double Buffered DMA with About Trigger Mode\n\n\n");
    fprintf( fp, "CH0 \n======================\n");

    do {
        do {
             usleep(10);
             D2K_AI_AsyncDblBufferHalfReady(card, &halfReady, &fStop);
        } while ( !halfReady && !fStop );
        if( !clear_op & !fStop ){
	     write_buffer_to_file();
             count += (read_count);
             printf("\r%ld", count);
	}
    } while(!clear_op && !fStop );

    
    err = D2K_AI_AsyncClear(card, &startPos, &count1);
    if( err != 0 ){
	printf("D2K_AI_AsyncClear Failed !!!, Ready to halt system !!!\n" );
    } 
    count += count1;

//    write_buffer_to_file();

    fclose( fp );

    printf("\n\n%ld input data are stored in file '%s'.\n", count, file_name);
    if( !clear_op )
	printf(" Press any key to exit \n" );

    return NULL;
}


int main( void )
{
    I16 err, Id;
    int card_num = 0;
    void* ret_val;

    setbuf( stdout, NULL );
    clrscr();
    
    printf("DAQ-2206 Double Buffered DMA with About Trigger Mode\n");
    printf("----------------------------------------------------\n");
    printf("This program inputs data from CH-%d of DAQ-2206#%d in %d Hz by\ndouble-buffer mode, and store data to file '%s'. The size of circular\nbuffer is %ld. \nAbout data acquisition with trigger signal on Pin-7 of Connector 2.\n\n",
           channel, card_num, 1000, file_name, read_count);
    printf("Please input a card number: ");
    scanf(" %i", &card_num);

    if( (fp = fopen( file_name, "w+b" ) ) == NULL )
	return -10;

    if ((card=D2K_Register_Card (DAQ_2206, (I16)card_num)) <0 ) {
        printf("Register_Card error=%d\n", card);
	D2K_Release_Card(card);
        return -1;
    }
    err = D2K_AI_CH_Config (card, channel, range);
    if (err!=0) {
	printf("D2K_AI_CH_Config error=%d", err);
	D2K_Release_Card(card);
	return -2;
    }
    err = D2K_AI_Config (card, 0, DAQ2K_AI_TRGSRC_ExtD | DAQ2K_AI_TRGMOD_MIDL|DAQ2K_AI_TrgPositive, postCount, 0, 0, 1);
    if (err!=0) {
	printf("D2K_AI_Config error=%d", err);
	D2K_Release_Card(card);
	return -2;
    }

    err = D2K_AI_AsyncDblBufferMode (card, 1);
    if (err!=0) {
	printf("DAQ2K_AI_DblBufferMode error=%d", err);
	D2K_Release_Card(card);
	return -3;
    }

    err = D2K_AI_ContBufferSetup (card, ai_buf, read_count, &Id);
    if (err!=0) {
        printf("D2K_AI_ContBufferSetup error=%d for the 1st buffer", err);
        D2K_Release_Card(card);
        return -2;
    }

    D2K_AI_ContBufferSetup (card, ai_buf2, read_count, &Id);
    if (err!=0) {
	printf("D2K_AI_ContBufferSetup error=%d for the 2nd buffer", err);
	D2K_Release_Card(card);
	return -3;
    }

    err = D2K_AI_ContReadChannel (card, channel, Id, read_count, samp_intrv, samp_intrv, ASYNCH_OP);
    if (err!=0) {
	printf("D2K_AI_ContScanChannels error=%d", err);
	D2K_Release_Card(card);
	return -4;
    }
    printf("\n\nPress any key to stop input operation.");
    printf("\n\nData count : \n");

    clear_op = FALSE;
    if( pthread_create( &pthread, NULL, ProcessThread, NULL ) !=0 ){
	printf(" Cannot create the Thread\n" );
        D2K_Release_Card(card);
	return -11;
    }
	
    getch();
    clear_op = TRUE;
    pthread_join( pthread, &ret_val );

    D2K_Release_Card(card);

    putchar('\n');
    return 0;
}

void write_buffer_to_file( void )
{
  U32 XferCnt, ActBufferAddr;
  I16 adinput[4];
  char s[50], temp_s[10];
  U32 i;
  int j;
  int chan_no = channel +1;

  D2K_AI_GetActiveBuffer( card, &ActBufferAddr, &XferCnt );
	
  for(i=0; i< XferCnt; i+=chan_no){
	memset( adinput, 0xff, 4*sizeof(I16) );
	for( j = 0; j < chan_no; j++ ){
        	adinput[j] = ((I16*)ActBufferAddr)[i+j];
    	}
    	s[0] = 0x00;
    	for( j = 0; j < chan_no; j++ ){
      		sprintf( temp_s, "%4.4f  ", (F32)(adinput[j]*ratio) );
      		//sprintf( temp_s, "%04x  ", adinput[j] );
      		strcat( s, temp_s );
    }
    strcat(s, "\n");
    fwrite(s, sizeof(U8), strlen(s), fp);
  }

}

