#include <stdlib.h>
#include <stdio.h>
#include "conio.h"
#include "d2kdask.h"

float value;

int main( void )
{
   I16 card = -1, err, i;
   int card_num, card_type = 1, answer;
   float offset_err=0.0;
   float gain_err;
   I16 chcnt = 8;

   printf("This program performs AD and DA auto-calibration\n");
   printf("Card Type: (0) DAQ_2501 or (1) DAQ2502 ? ");
   scanf(" %d", &card_type);
   printf("Please input a card number: ");
   scanf(" %d", &card_num);
   if( card_type == 1 ) card_type = DAQ_2502;
   else card_type = DAQ_2501;
   if ((card=D2K_Register_Card (card_type, (I16)card_num)) <0 ) {
        printf("Register_Card error=%d\n", card);
        exit(1);
   }
   printf("Press any key to start auto calibration ...");
   getch();
   printf("\nIt will take few minutes to finish ...");
   err= D2K_DB_Auto_Calibration_ALL(card);
   if(err != NoError)
	printf("\nAuto Calibration Failed %d.\n", err);
   else 
	printf("\nAuto Calibration Finished. \n");
	
   printf("=========================================\n");
   printf("AD Calibration Data : \n" );
   printf("------------------------------------------\n");

   DAQ250X_Acquire_AD_Error(0, 0, &gain_err, &offset_err);
   printf("AD 0 Unipolar Gain error: %4.4f\n", gain_err);
   printf("AD 0 Unipolar Offset error: %4.4f\n", offset_err);

   DAQ250X_Acquire_AD_Error(0, 1, &gain_err, &offset_err);
   printf("AD 1 Bipolar Gain error: %4.4f\n", gain_err);
   printf("AD 1 Bipolar Offset error: %4.4f\n", offset_err);

   printf("\n");
   printf("Press any key to show DA calibration Data...");
   getch();
   printf("\n------------------------------------------\n");
   printf("DA Calibration Unipolar Data : \n" );
   printf("------------------------------------------\n");

   if(card_type == DAQ_2501) 
	chcnt = 4;

   for(i=0; i<chcnt; i++) {
	DAQ250X_Acquire_DA_Error(0, i%8, 0, &gain_err, &offset_err);
	printf("DA %d Unipolar Gain error: Gain: %4.4f\n", i, gain_err);
	printf("DA %d Unipolar Offset error: Off: %4.4f\n", i, offset_err);
   }

   printf("\nPress any key to show DA Calibration Bipolar Data...");
   getch();
   printf("\n------------------------------------------\n");
   printf("DA Calibration Bipolar Data : \n" );
   printf("------------------------------------------\n");

   for(i=0; i<chcnt; i++) {
	DAQ250X_Acquire_DA_Error(0, i%8, 1, &gain_err, &offset_err);
	printf("DA %d Bipolar Dain error: Gain: %4.4f\n", i, gain_err);
	printf("DA %d Bipolar Offset error: Off: %4.4f\n", i, offset_err);
   }
 
/*
   printf("------------------------------------------\n");
   printf("Save the calibration constants into EEPROM on board : ");
   printf("Yes(1) or No(0)?");
   scanf(" %d", &answer);
   if(answer)
	err = D2K_EEPROM_CAL_Constant_Update(card, 0);
*/

   if(card>=0)
	D2K_Release_Card(card);

   return 0;
}
