#include <stdlib.h>
#include <stdio.h>
#include "conio.h"
#include "d2kdask.h"

#define BASETIME      40000000
#define SAMPLE_INTERVAL 160

U16 channel=3;  //4 channels
U16 range=AD_B_10_V;
char *file_name="250xd";
U32 read_count=4000;
I16 adinput;
short ai_buf[4000];

int main( void )
{
    I16 card, err, i, Id; 
    int card_num, card_type=0;

    setbuf( stdout, NULL );
    clrscr();

    printf("This program inputs %ld data from CH-0 to CH-%d of DAQ-2501/2502\nin %d Hz, andstore data to file '%s'.\nPlease press any key to start the operation.\n", read_count, channel, (int)(BASETIME/SAMPLE_INTERVAL/(channel+1)), file_name);
    printf("Card Type: (0) DAQ_2501 or (1) DAQ2502 ? ");
    scanf(" %d", &card_type);
    printf("Please input a card number: ");
    scanf(" %d", &card_num);
    if(card_type) card_type = DAQ_2502;
    else card_type = DAQ_2501;
    if((card = D2K_Register_Card(card_type, card_num))<0) {
	printf("Register_Card error=%d", card);
	return -1;
    }

    for(i=0; i<4; i++){
	err = D2K_AI_CH_Config (card, i, range);
	if (err != NoError) {
	    printf("D2K_AI_CH_Config error=%d", err);
	    D2K_Release_Card(card);
	    return -1;
	}
    }

    err = D2K_AI_Config (card, 0, 0, 0, 0, 0,1);
    if (err != NoError) {
	printf("D2K_AI_Config error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AI_ContBufferSetup (card, ai_buf, 4000, &Id);
    if (err != NoError) {
	printf("D2K_AI_ContBufferSetup error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AI_ContScanChannelsToFile(card, channel, Id, file_name, read_count/(channel+1), 160*(channel+1), 160, SYNCH_OP);
    if (err != NoError) {
	printf("D2K_AI_ContScanChannelsToFile error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }
    D2K_Release_Card(card);
    printf("\n\nThe input data is already stored in file '%s.dat'.\n", file_name);
    printf("\nPress ENTER to exit the program. "); getchar();

    return 0;

}
