#include <stdlib.h>
#include <stdio.h>
#include "conio.h"
#include "d2kdask.h"

#define CHANNELNUMBER All_Channels
#define CHANNELCOUNT  4
#define LASTCHANNELNUMBER  3
#define BASETIME      40000000
#define AIRANGE       AD_B_10_V
#define SCANCOUNT     1000
#define ADCONVERTSRC  DAQ2K_AI_ADCONVSRC_Int
#define ADTRIGSRC     DAQ2K_AI_TRGSRC_SOFT
#define ADTRIGMODE    DAQ2K_AI_TRGMOD_POST
#define BUFAUTORESET  1
#define SAMPLE_INTERVAL 400

short ai_buf[4000];
char cardStr[2][8] = {"DAQ2501", "DAQ2502"};
void show_channel_data(I16 *buf);

int main( void )
{
    I16 card, err, Id; 
    int card_num, card_type=0;

    setbuf( stdout, NULL );
    clrscr();

    printf("This program inputs %d scans from CH-0 to CH-%d of DAQ-2501/2502 in %d Hz.\n", SCANCOUNT, LASTCHANNELNUMBER, (int)(BASETIME/SAMPLE_INTERVAL/CHANNELCOUNT));
    printf("Card Type: (0) DAQ-2501 or (1) DAQ-2502 ? ");
    scanf(" %d", &card_type);
    if(card_type == 1) card_type = DAQ_2502;
    else card_type = DAQ_2501;

    printf("Please input a card number: ");
    scanf(" %d", &card_num);
    if ((card=D2K_Register_Card (card_type, (I16)card_num)) <0 ) {
	printf("Register_Card error=%d", card);
	return -1;
    }

    err = D2K_AI_CH_Config (card, CHANNELNUMBER, AIRANGE);
    if (err != NoError) {
	printf("D2K_AI_CH_Config error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_AI_Config (card, ADCONVERTSRC, ADTRIGSRC|ADTRIGMODE, 0, 0, 0, BUFAUTORESET);
    if (err != NoError) {
	printf("D2K_AI_Config error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AI_ContBufferSetup (card, ai_buf, SCANCOUNT*CHANNELCOUNT, &Id);
    if (err != NoError) {
	printf("D2K_AI_ContBufferSetup error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_AI_ContScanChannels (card, LASTCHANNELNUMBER, Id, SCANCOUNT, SAMPLE_INTERVAL*CHANNELCOUNT, SAMPLE_INTERVAL, SYNCH_OP);
    if (err != NoError) {
	printf("AI_ContScanChannels error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    show_channel_data(ai_buf);
    D2K_Release_Card(card);
    printf("\nPress ENTER to exit the program. "); getchar();

    return 0;
}

void show_channel_data( I16 *buf)
{
    int k;
    U32 i;

    printf(" >>>>>>>>>>>>>>> the first 100 valid scans  <<<<<<<<<<<<<<< \n");
    printf("                Ch0              Ch1             Ch2             Ch3\n");

    for (k=0; k<12; k++) {
	for( i=0+k*80; i<80+k*80 ; i=i+4 ){
	    printf(" input value :  %04x(%4.2fV)     %04x(%4.2fV)    %04x(%4.2fV)     %04x(%4.2fV)\n", \
		ai_buf[i]&0xffff, (F64)(ai_buf[i]) / 32768 * 10.0,\
		ai_buf[i+1]&0xffff, (F64)(ai_buf[i+1]) / 32768 * 10.0,\
		ai_buf[i+2]&0xffff, (F64)(ai_buf[i+2]) / 32768 * 10.0,\
		ai_buf[i+3]&0xffff, (F64)(ai_buf[i+3]) / 32768 * 10.0);
  	}
	
	printf("Press any key for the continued data...\n");
	getch();
    }
}

