#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "conio.h"
#include "d2kdask.h"

#define PI  3.14159

U16 channel=0;
U32 out_count=4096;
U32 samp_intrv = 4000;
short pattern1[4096];
short pattern2[4096];
short ao_buf[4096];
short ao_buf2[4096];

int main( void )
{
    I16 card, err, i, Id, j;
    int card_num;
    BOOLEAN halfReady;
    U32 count=0, count1;
    U16 DaId, da_ch[2]={0, 4};

    setbuf( stdout, NULL );
    clrscr();

    printf("Please input a card number: ");
    scanf(" %d", &card_num);
    //getch();
    if((card = D2K_Register_Card(DAQ_2502, (I16)card_num))<0) {
	printf("Error %d trying to open daq2010\n", card);
	return -1;
    }

    for (i=0;i<out_count;i++) 
	pattern1[i] = (I16)(sin((double)i/512*PI)*0x7ff)+0x800;
    for (i=0;i<out_count;i++) {
	if(i<2048)
	    pattern2[i] = (0x800+i%2048) & 0xfff;
	    //pattern2[i] = (0) & 0xfff;
	else 
	    pattern2[i] = (0x800+2047-(i%2048)) & 0xfff;
	    //pattern2[i] = (4095) & 0xfff;
    }	
    memcpy(ao_buf, pattern1, out_count*2);
    memcpy(ao_buf2, pattern1, out_count*2);
//  memcpy(ao_buf2, pattern2, out_count*2);

    err = D2K_AO_CH_Config (card, 0, DAQ2K_DA_BiPolar, DAQ2K_DA_Int_REF, 10.0);
    if (err != NoError) {
	printf("D2K_AO_CH_Config#0 error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AO_CH_Config (card, 4, DAQ2K_DA_BiPolar, DAQ2K_DA_Int_REF, 10.0);
    if (err != NoError) {
	printf("D2K_AO_CH_Config#4 error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AO_Group_Setup (card, DA_Group_AB, 2, da_ch);
    if (err != NoError) {
	printf("D2K_AO_Group_Setup error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AO_Config (card, DA_Group_AB, 0, 0, 0, 0, 0);
    if (err != NoError) {
	printf("D2K_AO_Config#DA_Group_AB error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AO_AsyncDblBufferMode (card, 1);
    if (err != NoError) {
	printf("D2K_AO_AsyncDblBufferMode error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AO_ContBufferSetup (card, ao_buf, out_count, &Id);
    if (err != NoError) {
	printf("D2K_AO_ContBufferSetup error=%d for the 1st buffer\n", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AO_ContBufferSetup (card, ao_buf2, out_count, &DaId);
    if (err != NoError) {
	printf("D2K_AO_ContBufferSetup error=%d for the 2nd buffer\n", err);
	D2K_AI_ContBufferReset (card);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AO_Group_WFM_Start (card, DA_Group_AB, Id, DaId, out_count/2, 0, samp_intrv, 1);
    if(err != NoError){
	printf("D2K_AO_Group_WFM_Start Error %d \n", err);
	D2K_AO_ContBufferReset (card);
	D2K_Release_Card(card);
	return -1;
    }

    j=0;
    printf("\n\nPress any key to stop input operation.");
    printf("\n\nData count : \n");
    do {
        do {
             D2K_AO_AsyncDblBufferHalfReady(card, &halfReady);
        } while (!halfReady);
	if(!(j%4))
	    memcpy(ao_buf, pattern2, out_count*2);
	else if((j%4)==1)
	    memcpy(ao_buf2, pattern2, out_count*2);
	else if((j%4)==2)
	    memcpy(ao_buf, pattern1, out_count*2);
	else
	    memcpy(ao_buf2, pattern1, out_count*2);

        count += (out_count);
        printf("%ld\r", count);
	j++;
    } while(!kb_hit());

    D2K_AO_Group_WFM_AsyncClear(card, DA_Group_AB, &count1,0);
    D2K_AO_ContBufferReset (card);
    count += (count1);
    D2K_Release_Card(card);

    printf("\nPress ENTER to exit the program. "); getchar();

    return 0;
}
