#include <stdlib.h>
#include <stdio.h>
#include "conio.h"
#include "d2kdask.h"

U16 channel=3;  //4 channels
U16 range=AD_B_10_V;
char *file_name="250xd";
U32 read_count=4000;
U32 samp_intrv = 10000;
short ai_buf[4000];
short ai_buf2[4000];

int main( void )
{
    I16 card, err, Id; 
    int card_num, card_type=0;
    BOOLEAN halfReady, fStop;
    U32 count=0, count1, startPos;

    setbuf( stdout, NULL );
    clrscr();

    printf("This program inputs data from CH-0 to CH-%d of DAQ-2501/2502 in scan rate %d Hz by double-buffer mode, and store data to file '%s.dat'. The size of circular\nbuffer is %ld. It will not stop until you press a key.\n\nPress any key to start the operation.\n", channel, 1000, file_name, read_count );

    printf("Card Type: (0) DAQ_2501 or (1) DAQ2502 ? ");
    scanf(" %d", &card_type);
    printf("Please input a card number: ");
    scanf(" %d", &card_num);
    if(card_type) card_type = DAQ_2502;
    else card_type = DAQ_2501;
    if((card = D2K_Register_Card(card_type, card_num))<0) {
	printf("Register_Card error=%d", card);
	return -1;
    }

    err = D2K_AI_CH_Config (card, -1, range);
    if (err != NoError) {
	printf("D2K_AI_CH_Config error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AI_Config (card, 0, DAQ2K_AI_TRGMOD_POST|DAQ2K_AI_TrgPositive, 0, 0, 0,1);
    if (err != NoError) {
	printf("D2K_AI_Config error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AI_AsyncDblBufferMode (card, 1);
    if (err != NoError) {
	printf("DAQ2K_AI_DblBufferMode error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AI_ContBufferSetup (card, ai_buf, read_count, &Id);
    if (err != NoError) {
	printf("D2K_AI_ContBufferSetup error=%d for the 1st buffer", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AI_ContBufferSetup (card, ai_buf2, read_count, &Id);
    if (err != NoError) {
	printf("D2K_AI_ContBufferSetup error=%d for the 2nd buffer", err);
	D2K_Release_Card(card);
	return -1;
    }
    err = D2K_AI_ContScanChannelsToFile (card, channel, Id, file_name, read_count/(channel+1), samp_intrv*(channel+1), samp_intrv, ASYNCH_OP);
    if (err != NoError) {
	printf("D2K_AI_ContScanChannels error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    printf("\n\nPress any key to stop input operation.");
    printf("\n\nData count : \n");
    do {
        do {
             D2K_AI_AsyncDblBufferHalfReady(card, &halfReady, &fStop);
        } while (!halfReady);
	    D2K_AI_AsyncDblBufferToFile(card);
        count += (read_count);
        printf("%ld\r", count);
    } while(!kb_hit());

    D2K_AI_AsyncClear(card, &startPos, &count1);
    count += (count1);
    D2K_Release_Card(card);
    printf("\n\n%ld input data are stored in file '%s.dat'.\n", count, file_name);
    printf("\nPress ENTER to exit the program. "); getchar();

    return 0;
}
