#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "conio.h"
#include "d2kdask.h"

#define PI           3.14159
#define out_count    4096
#define CHANNELNUM   All_Channels

U16 channel=0;
U32 samp_intrv = 4000;
short pattern1[out_count];
short pattern2[out_count];
short ao_buf[out_count];
short ao_buf2[out_count];

int main( void )
{
    I16 card, err, i, Id, j, chcnt = 4;
    int card_num, card_type;
    BOOLEAN halfReady;
    U32 count=0, count1;
    U16 DaId, da_ch[8], group = DA_Group_A;

    setbuf( stdout, NULL );
    clrscr();

    printf("This program demonstrates Double Buffered DA\n\n");

    printf("Card Type: (0) DAQ_2501 or (1) DAQ2502 ? ");
    scanf(" %d", &card_type);
    printf("Please input a card number: ");
    scanf(" %d", &card_num);

    if(card_type == 1) card_type = DAQ_2502;
    else card_type = DAQ_2501;

    if ((card=D2K_Register_Card (card_type, card_num)) <0 ) {
	printf("Register_Card error=%d\n", card);
	return -1;
    }

    for (i=0;i<out_count;i++) 
	pattern1[i] = (I16)(sin((double)i/512*PI)*0x7ff)+0x800;

    for (i=0;i<out_count;i++) {
	if(i<2048)
	    pattern2[i] = (0x800+i%2048) & 0xfff;
	else 
	    pattern2[i] = (0x800+2047-(i%2048)) & 0xfff;
    }	

    memcpy(ao_buf, pattern1, out_count*2);
    memcpy(ao_buf2, pattern1, out_count*2);

    err = D2K_AO_CH_Config (card, CHANNELNUM, DAQ2K_DA_BiPolar, DAQ2K_DA_Int_REF, 10.0);

    if (err != NoError) {
	printf("D2K_AO_CH_Config error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
    }

    chcnt = (card_type==DAQ_2502)? 8 : 4;
    for(i=0; i<chcnt; i++)
	da_ch[i] = i;

    group = (card_type==DAQ_2502)? DA_Group_AB : DA_Group_A;
    err = D2K_AO_Group_Setup (card, group, chcnt, da_ch);
    if (err!=NoError) {
	printf("D2K_AO_Group_Setup error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_AO_Config (card, group, DAQ2K_DA_TRGMOD_POST, 0, 0, 0,0);
    if (err != NoError) {
	printf("D2K_AO_Config error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_AO_AsyncDblBufferMode (card, 1);
    if (err != NoError) {
	printf("DAQ2K_AO_DblBufferMode error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_AO_ContBufferSetup (card, ao_buf, out_count, &Id);
    if (err!=0) {
	printf("D2K_AO_ContBufferSetup error=%d for the 1st buffer\n", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_AO_ContBufferSetup (card, ao_buf2, out_count, &DaId);
    if (err!=0) {
	printf("D2K_AO_ContBufferSetup error=%d for the 2nd buffer\n", err);
	D2K_AI_ContBufferReset (card);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_AO_Group_WFM_Start (card, group, Id, DaId, out_count/chcnt, 1, samp_intrv, 0);

    if(err!=NoError){
	printf("D2K_AO_Group_WFM_Start Error %d \n", err);
	D2K_AO_ContBufferReset (card);
	D2K_Release_Card(card);
	return -1;
    }

    j=0;
    printf("\n\nPress any key to stop input operation.");
    printf("\n\nData count : \n");

    do {
	do {
	    D2K_AO_AsyncDblBufferHalfReady(card, &halfReady);
	} while (!halfReady);

	if(!(j%4))
	    memcpy(ao_buf, pattern2, out_count*2);
	else if((j%4)==1)
	    memcpy(ao_buf2, pattern2, out_count*2);
	else if((j%4)==2)
	    memcpy(ao_buf, pattern1, out_count*2);
	else
	    memcpy(ao_buf2, pattern1, out_count*2);

	count += (out_count);
	printf("%ld\r", count);
	j++;
    } while(!kb_hit());

    D2K_AO_Group_WFM_AsyncClear(card, group, &count1,0);
    D2K_AO_ContBufferReset (card);
    count += (count1);
    D2K_Release_Card(card);
    printf("\nPress ENTER to exit the program. "); getchar();

    return 0;
}

