#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "conio.h"
#include "d2kdask.h"

#define PI  3.14159
#define CardNum   8
#define out_count 4096

U16 channel=0;
U32 samp_intrv = 4000;
U16 CardType[CardNum] = {DAQ_2005, DAQ_2006, DAQ_2010, DAQ_2016, DAQ_2204, DAQ_2205, DAQ_2206, DAQ_2213};
short pattern1[out_count];
short pattern2[out_count];
short ao_buf[out_count];
short ao_buf2[out_count];

int main( void )
{
   I16 card, err, i, Id, j;
   int card_num, card_type;
   BOOLEAN halfReady;
   U32 count=0, count1;

   setbuf( stdout, NULL );
   clrscr();

   printf("This program demonstrates Double Buffered DA\n\n");
   printf("--------------------------------------------\n");
   printf("0. DAQ-2005\n1. DAQ-2006\n2. DAQ-2010\n3. DAQ-2016\n4. DAQ-2204\n5. DAQ-2205\n6. DAQ-2206\n7. DAQ-2214\n");
   printf("--------------------------------------------\n");
   printf("Please select a card type: ");
   scanf(" %d", &card_type);
   card_type = CardType[card_type];
   printf("Please input a card number: ");
   scanf(" %d", &card_num);
   //getch();
   if ((card=D2K_Register_Card (card_type, card_num)) <0 ) {
        printf("Register_Card error=%d\n", card);
        exit(1);
   }

   for (i=0;i<out_count;i++) 
	pattern1[i] = (I16)(sin((double)i/512*PI)*0x7ff)+0x800;

   for (i=0;i<out_count;i++) {
	if(i<2048)
	    pattern2[i] = (0x800+i%2048) & 0xfff;
	else 
	    pattern2[i] = (0x800+2047-(i%2048)) & 0xfff;
   }

   memcpy(ao_buf, pattern1, out_count*2);
   memcpy(ao_buf2, pattern1, out_count*2);

   err = D2K_AO_CH_Config (card, 0, DAQ2K_DA_BiPolar, DAQ2K_DA_Int_REF, 10.0);
   if (err != NoError) {
	printf("D2K_AO_CH_Config error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
   }

   err = D2K_AO_Config (card, 0, DAQ2K_DA_TRGMOD_POST, 0, 0, 0,1);
   if (err != NoError) {
	printf("D2K_AO_Config error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
   }
   err = D2K_AO_AsyncDblBufferMode (card, 1);
   if (err != NoError) {
	printf("DAQ2K_AO_DblBufferMode error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
   }

   err = D2K_AO_ContBufferSetup (card, ao_buf, out_count, &Id);
   if (err != NoError) {
	printf("D2K_AO_ContBufferSetup error=%d for the 1st buffer\n", err);
	D2K_Release_Card(card);
	return -1;
   }

   err = D2K_AO_ContBufferSetup (card, ao_buf2, out_count, &Id);
   if (err != NoError) {
	printf("D2K_AO_ContBufferSetup error=%d for the 2nd buffer\n", err);
	D2K_AI_ContBufferReset (card);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_AO_ContWriteChannel (card, 0, Id, out_count, 2, samp_intrv, samp_intrv, ASYNCH_OP);
    if (err != NoError) {
	printf("D2K_AO_ContWriteChannel error=%d\n", err);
	D2K_AI_ContBufferReset (card);
	D2K_Release_Card(card);
	return -1;
    }
    j=0;
    printf("\n\nPress any key to stop input operation.");
    printf("\n\nData count : \n");

    do {
        do {
             D2K_AO_AsyncDblBufferHalfReady(card, &halfReady);
        } while (!halfReady);
	if(!(j%4))
	    memcpy(ao_buf, pattern2, out_count*2);
	else if((j%4)==1)
	    memcpy(ao_buf2, pattern2, out_count*2);
	else if((j%4)==2)
	    memcpy(ao_buf, pattern1, out_count*2);
	else
	    memcpy(ao_buf2, pattern1, out_count*2);
        count += (out_count);
        printf("%ld\r", count);
	j++;
    } while(!kb_hit());

    D2K_AO_AsyncClear(card, &count1, 0);
    count += (count1);
    D2K_Release_Card(card);
    printf("\nPress ENTER to exit the program. "); getchar();

    return 0;
}
