#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "conio.h"
#include "d2kdask.h"

///////////////////////////////////////////////////////////////////////////////
#define PI        3.14159
#define CardNum   8

I16 AO_buf[8192];
U32 data_size = 8192;
U16 CardType[CardNum] = {DAQ_2005, DAQ_2006, DAQ_2010, DAQ_2016, DAQ_2204, DAQ_2205, DAQ_2206, DAQ_2214};

int main(int argc, char* argv[])
{
   I16 card = -1, err, i;
   int card_num, card_type;
   U32 count;
   U16 DaId;
   BOOLEAN bStopped;

   setbuf( stdout, NULL );
   clrscr();

   printf("This program outputs data from AO CH-0 in %d Hz.\nThe size of buffer is %ld. The iteration is 2.\n\nPress any key to start the operation.\n\n",
           100000, data_size);
   printf("--------------------------------------------\n");
   printf("0. DAQ-2005\n1. DAQ-2006\n2. DAQ-2010\n3. DAQ-2016\n4. DAQ-2204\n5. DAQ-2205\n6. DAQ-2206\n7. DAQ-2214\n");
   printf("--------------------------------------------\n");
   printf("Please select a card type: ");
   scanf(" %d", &card_type);
   card_type = CardType[card_type];
   printf("Please input a card number: ");
   scanf(" %d", &card_num);
   if((card = D2K_Register_Card(card_type, (I16)card_num))<0) {
	printf("Error %d trying to open device\n", card);
	return -1;
   }

   for(i=0; i<8192; i++)
	AO_buf[i]=(I16)(sin((double)i/512*PI)*0x7ff)+0x800;

   err = D2K_AO_CH_Config (card, 0, DAQ2K_DA_BiPolar, DAQ2K_DA_Int_REF, 10.0);
   if(err!=NoError){
	printf("D2K_AO_CH_Config Error %d \n", err);
	D2K_Release_Card(card);
	return -1;
   }

   err = D2K_AO_Config (card, 0, DAQ2K_DA_TRGMOD_POST|DAQ2K_DA_TRGSRC_ExtD|DAQ2K_DA_ReTrigEn, 4, 0, 0,1);
   if(err!=NoError){
	printf("D2K_AO_Config Error %d \n", err);
	D2K_Release_Card(card);
	return -1;
   }

   err = D2K_AO_ContBufferSetup (card, AO_buf, data_size, &DaId);
   if(err!=NoError){
	printf("D2K_AO_ContBufferSetup Error %d \n", err);
	D2K_Release_Card(card);
	return -1;
   }

   err = D2K_AO_ContWriteChannel (card, 0, DaId, data_size, 2, 400, 1, ASYNCH_OP);
   if(err!=NoError){
	printf("D2K_AO_ContWriteChannel Error %d \n", err);
	D2K_AO_ContBufferReset (card);
	D2K_Release_Card(card);
	return -1;
   }

   do {
	D2K_AO_AsyncCheck(card, &bStopped, &count);
   } while (!bStopped);

   D2K_AO_AsyncClear(card, &count,0);

   getchar();
   D2K_Release_Card(card);
 
   return 0;
}// main

