#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include "conio.h"
#include "d2kdask.h"

U16 channel=0;  //1 channels
U16 range=AD_B_10_V;
char *file_name="2000d";
U32 read_count=4000;
U32 samp_intrv = 1000;
unsigned short ai_buf[4000];
unsigned short ai_buf2[4000];

#define CardNum   12

U16 CardType[CardNum] = {DAQ_2005, DAQ_2006, DAQ_2010, DAQ_2016, DAQ_2204, DAQ_2205, DAQ_2206, DAQ_2208, DAQ_2213, DAQ_2214, DAQ_2501, DAQ_2502};

int main( void )
{
    I16 card, err, Id, fok; 
    int card_num, card_type=DAQ_2010;
    BOOLEAN halfReady, fStop;
    U32 count=0, count1, startPos, t=0;
    U16 sts=0;
    setbuf( stdout, NULL );
    clrscr();

    printf("This program inputs data from CH-0 in %d Hz by\ndouble-buffer mode, and store data to file '%s.dat'. The size of circular\nbuffer is %ld. It will not stop until you press a key.\n\nPress any key to start the operation.\n",
           1000, file_name, read_count);
    printf("--------------------------------------------\n");
    printf("0. DAQ-2005\n1. DAQ-2006\n2. DAQ-2010\n3. DAQ-2016\n4. DAQ-2204\n5. DAQ-2205\n6. DAQ-2206\n7. DAQ-2208\n8. DAQ-2213\n9. DAQ-2214\n10. DAQ-2501\n11. DAQ-2502\n");
    printf("--------------------------------------------\n");
    printf("Please select a card type: ");
    scanf(" %d", &card_type);
    card_type = CardType[card_type];
    printf("Please input a card number: ");
    scanf(" %d", &card_num);
 	printf("Save data to a file (AdData.dat): Yes(1) or No(0)? ");
	scanf(" %d", &fok); 
    if((card = D2K_Register_Card(card_type, (I16)card_num))<0) {
	printf("Register_Card error=%d\n", card);
	return -1;
    }
    err = D2K_AI_CH_Config (card, -1, range);
    if (err != NoError) {
	printf("D2K_AI_CH_Config error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_AI_Config (card, 0, DAQ2K_AI_TRGMOD_POST|DAQ2K_AI_TrgPositive, 0, 0, 0,1);
    if (err != NoError) {
	printf("D2K_AI_Config error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_AI_AsyncDblBufferMode (card, 1);
    if (err != NoError) {
	printf("D2K_AI_DblBufferMode error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_AI_ContBufferSetup (card, ai_buf, read_count, &Id);
    if (err != NoError) {
	printf("D2K_AI_DblBufferSetup#0 error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    D2K_AI_ContBufferSetup (card, ai_buf2, read_count, &Id);
    if (err != NoError) {
	printf("D2K_AI_DblBufferSetup#1 error=%d", err);
	D2K_AI_ContBufferReset(card);
	D2K_Release_Card(card);
	return -1;
    }
     t=0;
      if(fok) 
	err = D2K_AI_ContScanChannelsToFile (card, channel, Id, file_name, read_count/(channel+1), samp_intrv, samp_intrv, ASYNCH_OP); 
     else 
    err = D2K_AI_ContScanChannelsToFile (card, channel, Id, file_name,read_count/(channel+1), samp_intrv, samp_intrv, ASYNCH_OP);     
      if (err!=0) {
	printf("D2K_AI_ContScanChannels error=%d", err); 
             D2K_AI_ContBufferReset(card); 	D2K_Release_Card(card);
	return -1;
    }
    printf("\n\nPress any key to stop input operation.");
    printf("\n\nData count : \n");
    do {
        do {
             D2K_AI_AsyncDblBufferHalfReady(card, &halfReady, &fStop);
        } while (!halfReady);
	if(fok) 
		D2K_AI_AsyncDblBufferToFile(card); //storing data to a file and then telling driver that data are handled 
	else { 
			//TODO: here to handle data 
	        D2K_AI_AsyncDblBufferHandled(card); //telling driver that data are handled 
	} 
	//D2K_AI_AsyncDblBufferToFile(card);
        count += (read_count);
//        printf("%ld\r", count);
       D2K_AI_AsyncDblBufferOverrun(card, 0, &sts); //checking overrun status
 	if(sts) {//ovrerrun is happened
  			t++; 
			D2K_AI_AsyncDblBufferOverrun(card, 1, &sts); //clear overrun flag 
		} 
		printf("\roverrun:%d, count: %d", t, count); 
    } while(!kb_hit());
    D2K_AI_AsyncClear(card, &startPos, &count1);
    count += (count1);
    D2K_Release_Card(card);
    if(fok)
	    printf("\n\n%ld input data are stored in file '%s.dat'.\n", count, file_name);
    else
	    printf("\n\n%ld input data are acquired.\n", count);
    printf("\nPress ENTER to exit the program. "); getchar();

    return 0;
}
