#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <conio.h>
#include "d2kdask.h"

#define CardNum   12

U16 CardType[CardNum] = {DAQ_2005, DAQ_2006, DAQ_2010, DAQ_2016, DAQ_2204, DAQ_2205, DAQ_2206, DAQ_2208, DAQ_2213, DAQ_2214, DAQ_2501, DAQ_2502};

int main(void)
{
    I16 card, err; 
    int card_num, card_type;
    U32 input = 0;

    setbuf( stdout, NULL );
    clrscr();

    printf("This program inputs data from PA/PB/PC.\n");
    printf("This program demonstrates General purpose timer/counter GPTC0\n\n");
    printf("--------------------------------------------\n");
    printf("0. DAQ-2005\n1. DAQ-2006\n2. DAQ-2010\n3. DAQ-2016\n4. DAQ-2204\n5. DAQ-2205\n6. DAQ-2206\n7. DAQ-2208\n8. DAQ-2213\n9. DAQ-2214\n10. DAQ-2501\n11. DAQ-2502\n");
    printf("--------------------------------------------\n");
    printf("Please select a card type: ");
    scanf(" %d", &card_type);
    card_type = CardType[card_type];
    printf("Please input a card number: ");
    scanf(" %d", &card_num);

    if ((card=D2K_Register_Card (card_type, card_num)) <0 ) {
	printf("Register_Card error=%d", card);
	return -1;
    }

    //config port A/B/C as input port
    err = D2K_DIO_PortConfig(card,Channel_P1A, INPUT_PORT);
    if (err != NoError) {
	printf("D2K_DIO_PortConfig error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_DIO_PortConfig(card,Channel_P1B, INPUT_PORT);
    if (err != NoError) {
	printf("D2K_DIO_PortConfig error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_DIO_PortConfig(card,Channel_P1C, INPUT_PORT);
    if (err != NoError) {
	printf("D2K_DIO_PortConfig error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    do{
        printf ("-------------------------------------------------\n");
	err = D2K_DI_ReadPort(card,  Channel_P1A, &input);
	if (err != NoError) {
	    printf("D2K_DI_ReadPort error=%d", err);
	    D2K_Release_Card(card);
	    return -1;
	}
	printf(" P1A input = 0x%x\n", (U16)input);
  	err = D2K_DI_ReadPort(card,  Channel_P1B, &input);
	if (err != NoError) {
	    printf("D2K_DI_ReadPort error=%d", err);
	    D2K_Release_Card(card);
	    return -1;
	}
	printf(" P1B input = 0x%x\n", (U16)input);
  	err = D2K_DI_ReadPort(card,  Channel_P1C, &input);
	if (err != NoError) {
	    printf("D2K_DI_ReadPort error=%d", err);
	    D2K_Release_Card(card);
	    return -1;
	}

  	printf(" P1C input = 0x%x\n", (U16)input);
        printf ("-------------------------------------------------\n");
	printf ("\n Press any key to stop...\n");
	usleep(200000);
    } while(!kb_hit());

    D2K_Release_Card(card);

    return 0;
}

