#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include "conio.h"
#include "d2kdask.h"

#define CardNum   12

U16 CardType[CardNum] = {DAQ_2005, DAQ_2006, DAQ_2010, DAQ_2016, DAQ_2204, DAQ_2205, DAQ_2206, DAQ_2208, DAQ_2213, DAQ_2214, DAQ_2501, DAQ_2502};

int main(void)
{
    I16 card, err; 
    int card_num, card_type;
    U32 out_value = 0;

    setbuf( stdout, NULL );
    clrscr();

    printf("This program outputs data to PA/PB/PC.\n");
    printf("--------------------------------------------\n");
    printf("0. DAQ-2005\n1. DAQ-2006\n2. DAQ-2010\n3. DAQ-2016\n4. DAQ-2204\n5. DAQ-2205\n6. DAQ-2206\n7. DAQ-2208\n8. DAQ-2213\n9. DAQ-2214\n10. DAQ-2501\n11. DAQ-2502\n");
    printf("--------------------------------------------\n");
    printf("Please select a card type: ");
    scanf(" %d", &card_type);
    card_type = CardType[card_type];
    printf("Please input a card number: ");
    scanf(" %d", &card_num);
    if ((card=D2K_Register_Card (card_type, (I16)card_num)) <0 ) {
	printf("Register_Card error=%d", card);
	return -1;
    }
    //config port A/B/C as input port
    err = D2K_DIO_PortConfig(card,Channel_P1A, OUTPUT_PORT);
    if (err != NoError) {
	printf("D2K_DIO_PortConfig error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_DIO_PortConfig(card,Channel_P1B, OUTPUT_PORT);
    if (err != NoError) {
	printf("D2K_DIO_PortConfig error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    err = D2K_DIO_PortConfig(card,Channel_P1C, OUTPUT_PORT);
    if (err != NoError) {
	printf("D2K_DIO_PortConfig error=%d", err);
	D2K_Release_Card(card);
	return -1;
    }

    do{
        printf ("-------------------------------------------------\n");
  	err = D2K_DO_WritePort(card, Channel_P1A, out_value);
	if (err != NoError) {
	    printf("D2K_DO_WritePort error=%d", err);
	    D2K_Release_Card(card);
	    return -1;
	}
	printf(" P1A output = 0x%x\n", (U16)out_value);
  	err = D2K_DO_WritePort(card, Channel_P1B, out_value);
	if (err != NoError) {
	    printf("D2K_DO_WritePort error=%d", err);
	    D2K_Release_Card(card);
	    return -1;
	}
	printf(" P1B input = 0x%x\n", (U16)out_value);
  	err = D2K_DO_WritePort(card, Channel_P1C, out_value);
	if (err != NoError) {
	    printf("D2K_DO_WritePort error=%d", err);
	    D2K_Release_Card(card);
	    return -1;
	}
 	printf(" P1C output = 0x%x\n", (U16)out_value);
        printf ("-------------------------------------------------\n");
	printf ("\n Press any key to stop...\n");
	usleep(200000);
        out_value = (out_value + 1) % 256;

    } while(!kb_hit());

    D2K_Release_Card(card);
 
   return 0;
}

