/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                                         ;;
;;      File Name  :   DioPolling.C                                       ;;
;;      Purpose    :   This PCI-DASK sample program demonstrate how to    ;;
;;                     operate  DI & DO	for DAQ-2000 Serial          	  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include "conio.h"
#include "d2kdask.h"

#define GP0_value 40000
#define CardNum   12

U16 CardType[CardNum] = {DAQ_2005, DAQ_2006, DAQ_2010, DAQ_2016, DAQ_2204, DAQ_2205, DAQ_2206, DAQ_2208, DAQ_2213, DAQ_2214, DAQ_2501, DAQ_2502};

int main( void )
{
    I16 card = -1; 
    int card_num = 0, card_type;
    U32 outputA ,inputB ,outputC ,inputD;

    setbuf( stdout, NULL );
    clrscr();

    printf(" ******************************************************\n" );
    printf(" DAQ2000 DIO common sample:\n" );
    printf(" Connect Port A to Port B , Port C_Low to Port C_High \n" );
    printf(" *******************************************************\n" );
    printf("0. DAQ-2005\n1. DAQ-2006\n2. DAQ-2010\n3. DAQ-2016\n4. DAQ-2204\n5. DAQ-2205\n6. DAQ-2206\n7. DAQ-2208\n8. DAQ-2213\n9. DAQ-2214\n10. DAQ-2501\n11. DAQ-2502\n");
    printf(" *******************************************************\n\n" );
    printf("Please select a card type: ");
    scanf(" %d", &card_type);
    card_type = CardType[card_type];
    printf("Please input a card number: ");
    scanf(" %d", &card_num);

    if ((card=D2K_Register_Card (card_type, (I16)card_num)) <0 ) {
	printf("Register_Card error=%d\n", card);
	return -1;
    }

    D2K_DIO_PortConfig( card, Channel_P1A, OUTPUT_PORT );
    D2K_DIO_PortConfig( card, Channel_P1B, INPUT_PORT);
    D2K_DIO_PortConfig( card, Channel_P1CL, OUTPUT_PORT);
    D2K_DIO_PortConfig( card, Channel_P1CH, INPUT_PORT);


    printf("\n              press any key to terminate program .....\n\n");
    printf(" Port A      Port B      Port CL      Port CH \n" );   
    printf(" -------------------------------------------- \n\n" );   
    outputA = 0; outputC = 0;
    do{
	D2K_DO_WritePort( card, Channel_P1A, outputA );
	D2K_DO_WritePort( card, Channel_P1CL, outputC );
	usleep(1000);
	D2K_DI_ReadPort( card, Channel_P1B, &inputB );
	D2K_DI_ReadPort( card, Channel_P1CH, &inputD );
	printf("\r %06lx       %06lx       %06lx        %06lx  ", outputA, inputB, outputC, inputD );   
	outputA ++;
	outputA = outputA & 0x0FF;
	outputC = outputA & 0x0F;
                                        
    }while( !kb_hit() );

    D2K_Release_Card(card); 
    putchar('\n');

    return 0;
}


