#include <stdio.h>
#include <unistd.h>
#include "conio.h"
#include "d2kdask.h"

#define GP0_value 40000
#define CardNum   11

U16 CardType[CardNum] = {DAQ_2005, DAQ_2006, DAQ_2010, DAQ_2016, DAQ_2204, DAQ_2205, DAQ_2206, DAQ_2213, DAQ_2214, DAQ_2501, DAQ_2502};

U32 start_count, current_count;
F64 take_msec;
char buf[50];
int main(void)
{
	I16 card = -1, err; 
	int card_num, card_type;
	U32 pValue = 0, oldVal;
	U16 times = 0, status;

	setbuf( stdout, NULL );
	clrscr();

	printf("This program demonstrates General purpose timer/counter GPTC0\n\n");
	printf("--------------------------------------------\n");
    printf("0. DAQ-2005\n1. DAQ-2006\n2. DAQ-2010\n3. DAQ-2016\n4. DAQ-2204\n5. DAQ-2205\n6. DAQ-2206\n7. DAQ-2213\n8. DAQ-2214\n9. DAQ-2501\n10. DAQ-2502\n");
	printf("--------------------------------------------\n");
	printf("Please select a card type: ");
	scanf(" %d", &card_type);
	card_type = CardType[card_type];
	printf("Please input a card number: ");
	scanf(" %d", &card_num);

	if ((card=D2K_Register_Card (card_type, (I16)card_num)) <0 ) {
	    printf("Register_Card error=%d\n", card);
	    return -1;
	}

	clrscr();

	printf(" Begin of SimpleGatedEventCNT for GPTC0_OUT \n" ); 
	printf(" Connect the Trigger Signal to GPTC0_GATE \n");
	printf(" GND/Open to disable/enable the GATE of timer\n" );
	printf(" Press any key to continue" ); getch();

/* Procedure of SimpleGatedEventCNT Testing */ 
	err = D2K_GCTR_Reset(card, 0);
	err = D2K_GCTR_Setup (card, 0, SimpleGatedEventCNT, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_INT|D2K_GPTC_UPDOWN_SEL_INT, 0, 0x1000, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);

	printf("\n\n\n\n\n\n Press any key to end SimpleGateEventCNT testing\n" );
	do{
	    err = D2K_GCTR_Read (card, 0, &pValue );
	    printf("\r err:%d  Counter: %08ld", err, pValue );
	}while( !kb_hit() );

	clrscr(); 

/* Procedure of SingleGatedPulseGen Testing */ 
	printf("\n Begin of SingleGatedPulseGen for GPTC0_OUT\n" ); 
	printf(" Connect the Trigger Signal to GPTC0_GATE \n");
	printf(" GND/Open to disable/enable the GATE of timer\n" );
	printf(" Check the GPTC0_OUT status \n" );
	printf(" Press any key to continue" ); getch();

	D2K_GCTR_Reset(card, 0);
	err = D2K_GCTR_Setup ( card, 0, SingleGatedPulseGen, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_INT|D2K_GPTC_UPDOWN_SEL_INT, 0, 0xFFFF, 0xFFFF );

	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntGATE, 0);

	printf("\n\n\n\n\n\n 			press any key to continue \n" );
	getch();
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 0);
	clrscr();

/* Procedure of SingleTrigPulseGen Testing */ 
	printf("\n Begin of SingleTrigPulseGen for GPTC0_OUT\n" ); 
	printf(" Connect the Trigger Signal to GPTC0_GATE\n");
	printf(" GND/Open to disable/enable the GATE of timer\n\n" );
	printf(" Check the GPTC0_OUT status \n" );
	printf(" Press any key to continue" ); getch();

	D2K_GCTR_Reset(card, 0);
	err = D2K_GCTR_Setup ( card, 0, SingleTrigPulseGen, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_INT|D2K_GPTC_UPDOWN_SEL_INT, 0, 0xFFFF, 0xFFFF );

	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntGATE, 0);

	printf("\n\n\n\n\n\n press any key to continue \n" );
	getch();
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 0);
	clrscr();

/* Procedure of SinglePeriodMSR Testing */ 
	printf("\n Begin of SinglePeriodMSR \n" ); 
	printf(" Connect the Measured Signal to GPTC0_GATE\n");
	printf(" Press any key to continue" ); getch();

	D2K_GCTR_Reset(card, 0);
	err = D2K_GCTR_Setup (card, 0, SinglePeriodMSR, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_INT|D2K_GPTC_UPDOWN_SEL_INT, 0, 0, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);
	D2K_GCTR_Read (card, 0, &pValue);
	oldVal = pValue;
	times = 0;

	do {
		D2K_GCTR_Read (card, 0, &pValue);
		if( oldVal > pValue ) times ++;
		oldVal = pValue;
		D2K_GCTR_Status (card, 0, &status);
	} while (!(status & 0x08));

	D2K_GCTR_Read (card, 0, &pValue);
	printf("\n\n\n\n\n\n value = %ld\n", times*65536 + pValue);
	printf(" End of SinglePeroidMSR, please any key to continue\n" ); 
	getch();
	clrscr();

/* Procedure of SinglePulsWidthMSR Testing */ 
	printf("\n Begin of SinglePulseWidthMSR\n" ); 
	printf(" Connect the Measured Signal to GPTC0_GATE\n");
	printf(" Press any key to continue" ); getch();

	err = D2K_GCTR_Setup (card, 0, SinglePulseWidthMSR, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_INT|D2K_GPTC_UPDOWN_SEL_INT, 0, 0, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);

	D2K_GCTR_Read (card, 0, &pValue);
	oldVal= pValue;
	times = 0;
	do {
		D2K_GCTR_Read (card, 0, &pValue);
		if( oldVal > pValue ) times ++;
		oldVal = pValue;
		D2K_GCTR_Status (card, 0, &status);
	} while (!(status & 0x08));

	D2K_GCTR_Read (card, 0, &pValue);
	printf("\n\n\n\n\n\n value = %ld\n", times*65536 + pValue);
	printf(" End of SinglePulseWidthMSR, please any key to continue\n" ); 
	getch();
	clrscr();

/* Procedure of RetrigSinglePulseGen Testing */ 
	printf("\n Begin of RetrigSinglePulseGen for GPTC0_OUT\n" ); 
	printf(" Connect the Periodic Trigger Signal to GPTC0_GATE\n");
	printf(" Press any key to continue" ); getch();

	D2K_GCTR_Reset(card, 0);
	err = D2K_GCTR_Setup ( card, 0, RetrigSinglePulseGen, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_INT|D2K_GPTC_UPDOWN_SEL_INT, 0, 0xFFFF, 0xFFFF );

	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntGATE, 0);

	printf("\n\n\n\n\n\n Check the GPTC0_OUT status and press any key to continue \n" );
	getch();
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 0);
	clrscr();

/* Procedure of SingleTrigContPulseGen Testing */ 
	printf("\n Begin of SingleTrigContPulseGen for GPTC0_OUT\n" ); 
	printf(" Connect the Trigger Signal to GPTC0_GATE\n");
	printf(" and External Clock to GPTC0_SRC\n" );
	printf(" Press any key to continue" ); getch();

	D2K_GCTR_Reset(card, 0);
	err = D2K_GCTR_Setup ( card, 0, SingleTrigContPulseGen, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_EXT|D2K_GPTC_UPDOWN_SEL_INT, 0, 2, 2 );

	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntGATE, 0);

	printf("\n\n\n\n\n\n Check the GPTC0_OUT status and press any key to continue \n" );
	getch();
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 0);
	clrscr();

/* Procedure of ContGatedPulseGen Testing */ 
	printf("\n Begin of ContGatedPulseGen for GPTC0_OUT\n" ); 
	printf(" Connect the Trigger Signal to GPTC0_GATE\n");
	printf(" and External Clock to GPTC0_SRC\n" );
	printf(" GND/Open to disable/enable the GATE of timer\n" );
	printf(" Press any key to continue" ); getch();

	D2K_GCTR_Reset(card, 0);
	err = D2K_GCTR_Setup ( card, 0, ContGatedPulseGen, D2K_GPTC_GATESRC_EXT|D2K_GPTC_CLKSRC_EXT|D2K_GPTC_UPDOWN_SEL_INT, 0, 2, 2 );

	err = D2K_GCTR_Control (card, 0, GPTC_IntUpDnCTR, 0);
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 1);
	err = D2K_GCTR_Control (card, 0, GPTC_IntGATE, 0);

	printf("\n\n\n\n\n\n Check the GPTC0_OUT status and press any key to EXIT \n" );
	getch();
	err = D2K_GCTR_Control (card, 0, GPTC_IntENABLE, 0);

	if(card>=0)
		D2K_Release_Card(card);

	return 0;
}

