#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <pthread.h>
#include <sys/mman.h>
#include <math.h>
#include <sys/time.h>
#include <conio.h>
#include "d2kdask.h"

#define PI  3.14159
#define out_count 4096

U16 channel = 3;  //4 channels
U16 chans[4]={0,1,2,3};
U16 range = AD_B_10_V;
char file_name[20] = "dmaData.txt";
U32 read_count = 48000;
U32 samp_intrv = 4000;
unsigned short ai_buf[48000];
unsigned short ai_buf2[48000];
int buf_index;
short pattern1[out_count];
short pattern2[out_count];
short ao_buf[out_count];
short ao_buf2[out_count];

BOOLEAN clear_op;
I16 card = -1, multi = 0;
U32 count = 0, dacount = 0, t=0;
U16 actBuf = 0;
FILE* fp;
struct timeval tv_start, tv_end;
struct timezone tz;

#pragma pack(push,1)

typedef struct _D2K_MODULE_PARAM
{
		short	card_number;			
		short	card_type;	
		unsigned short ch;
		unsigned long   scancount;
		unsigned long   scan_interval;
}
D2K_MODULE_PARAM;

#pragma pack(pop)

D2K_MODULE_PARAM param, aoparam;

void write_buffer_to_file( void );

#if 0
void signal_handler(int sig_no)
{
     BOOLEAN halfReady, fStop;
     U16 sts=0;

     D2K_AI_AsyncDblBufferHalfReady(card, &halfReady, &fStop);
     write_buffer_to_file();
     D2K_AI_AsyncDblBufferHandled(card);     
     actBuf = (actBuf+1)%2;
     count += (read_count);
     D2K_AI_AsyncDblBufferOverrun(card, 0, &sts); //checking overrun status
     if(sts) {//ovrerrun is happened
              t++;
              D2K_AI_AsyncDblBufferOverrun(card, 1, &sts); //clear overrun flag
             }
     printf("\roverrun:%d, count: %d", t, count);
}

void signal_handler2(int sig_no)
{
     printf("\nfinish\n");
}
#endif

void dbevt_handler(int type, void* arg)
{  
     BOOLEAN halfReady, fStop;
     U16 sts=0;
     struct timeval tv_start, tv_end;

     gettimeofday( &tv_end, &tz );
     printf("\nAI_DB: evt_%hd|cardtype_%hd|cardid_%hd\n", type, ((D2K_MODULE_PARAM *) arg)->card_type, ((D2K_MODULE_PARAM *) arg)->card_number);
     printf("current time for AIDBF is: %ld.%06ld sec, ", tv_end.tv_sec, tv_end.tv_usec);
     D2K_AI_AsyncDblBufferHalfReady(card, &halfReady, &fStop);
     write_buffer_to_file();
     D2K_AI_AsyncDblBufferHandled(card);     
     actBuf = (actBuf+1)%2;
     count += (read_count);
     D2K_AI_AsyncDblBufferOverrun(card, 0, &sts); //checking overrun status
     if(sts) {//ovrerrun is happened
              t++;
              D2K_AI_AsyncDblBufferOverrun(card, 1, &sts); //clear overrun flag
             }

     printf("overrun:%ld, count: %ld\n\n", t, count);
}

void evt_handler(int type, void* arg)
{  

    printf("\nai finish\n");

}

void dbdaevt_handler(int type, void* arg)
{
   BOOLEAN halfReady;

   gettimeofday( &tv_end, &tz );

   printf("DA_DB: evt_%hd|cardtype_%hd|cardid_%hd\n", type, ((D2K_MODULE_PARAM *) arg)->card_type, ((D2K_MODULE_PARAM *) arg)->card_number);
   printf("current time for DADBF is: %ld.%06ld sec, ", tv_end.tv_sec, tv_end.tv_usec);

   D2K_AO_AsyncDblBufferHalfReady (card, &halfReady);
    if(!(buf_index%4))
	memcpy(ao_buf, pattern2, out_count*2);
    else if((buf_index%4)==1)
	memcpy(ao_buf2, pattern2, out_count*2);
    else if((buf_index%4)==2)
	memcpy(ao_buf, pattern1, out_count*2);
    else
	memcpy(ao_buf2, pattern1, out_count*2);

    dacount += (out_count);
    printf("dacount:%ld\n", dacount);
    buf_index++;
}

void daevt_handler(int type, void* arg)
{
     printf("\nda finish\n");
}

#define CardNum   12

U16 CardType[CardNum] = {DAQ_2005, DAQ_2006, DAQ_2010, DAQ_2016, DAQ_2204, DAQ_2205, DAQ_2206, DAQ_2208, DAQ_2213, DAQ_2214, DAQ_2501, DAQ_2502};

int main( void )
{
    I16 err=0;
    U16 Id=0, daId=0;
    int card_num = 0, card_type = DAQ_2010;
    U32 count1, startPos, dacount1;
    int i=0;
    D2K_MODULE_PARAM param;

    setbuf( stdout, NULL );
    clrscr();
    
    printf("This program inputs data from CH-0 to CH-%d of DAQ-2000#%d in %d Hz by\ndouble-buffer mode, and store data to file '%s'. The size of circular\nbuffer is %ld. It will not stop until you press a key.\n\n",
           channel, card_num, 1000, file_name, read_count);
    printf("--------------------------------------------\n");
    printf("0. DAQ-2005\n1. DAQ-2006\n2. DAQ-2010\n3. DAQ-2016\n4. DAQ-2204\n5. DAQ-2205\n6. DAQ-2206\n7. DAQ-2208\n8. DAQ-2213\n9. DAQ-2214\n10. DAQ-2501\n11. DAQ-2502\n");
    printf("--------------------------------------------\n");
    printf("Please select a card type: ");
    scanf(" %d", &card_type);
    if(card_type>2)
        multi = 1;
    else
        multi = 0;
    card_type = CardType[card_type];

    printf("Please input a card number: ");
    scanf(" %i", &card_num);
    if( (fp = fopen( file_name, "w+b" ) ) == NULL )
	return -10;
    fprintf( fp, " ContScanChannels with Double Buffer Transfer \n\n\n");
    fprintf( fp, "CH0   CH1   CH2   CH3 \n======================\n");
    if ((card=D2K_Register_Card (card_type, (I16)card_num)) <0 ) {
        printf("Register_Card error=%d\n", card);
        return -1;
    }

	//set callback param
	param.card_number=card;
	param.card_type=card_type;
	param.ch=(channel+1);
	param.scan_interval=samp_intrv;
	param.scancount=(multi)? (read_count/(channel+1)):read_count;

	//set callback param
	aoparam.card_number=card;
	aoparam.card_type=card_type;
	aoparam.ch=0;
	aoparam.scan_interval=samp_intrv;
	aoparam.scancount=out_count;

    D2K_AI_CH_Config (card, -1, range);
    err = D2K_AI_Config (card, 0, DAQ2K_AI_TRGMOD_POST|DAQ2K_AI_TrgPositive, 0, 0, 0,1);
    if (err!=0) {
       printf("D2K_AI_Config error=%d", err);
       exit(1);
    }
    err = D2K_AI_AsyncDblBufferMode (card, 1);
    if (err!=0) {
       printf("DAQ2K_AI_DblBufferMode error=%d", err);
       return -3;
    }

  for (i=0;i<out_count;i++) 
	pattern1[i] = (I16)(sin((double)i/512*PI)*0x7ff)+0x800;

   for (i=0;i<out_count;i++) {
	if(i<2048)
	    pattern2[i] = (0x800+i%2048) & 0xfff;
	else 
	    pattern2[i] = (0x800+2047-(i%2048)) & 0xfff;
   }

   memcpy(ao_buf, pattern1, out_count*2);
   memcpy(ao_buf2, pattern1, out_count*2);

   err = D2K_AO_CH_Config (card, 0, DAQ2K_DA_BiPolar, DAQ2K_DA_Int_REF, 10.0);
   if (err != NoError) {
	printf("D2K_AO_CH_Config error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
   }

   err = D2K_AO_Config (card, 0, DAQ2K_DA_TRGMOD_POST, 0, 0, 0,1);
   if (err != NoError) {
	printf("D2K_AO_Config error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
   }
   err = D2K_AO_AsyncDblBufferMode (card, 1);
   if (err != NoError) {
	printf("DAQ2K_AO_DblBufferMode error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
   }

    //setup signal handler
#if 0
    D2K_AI_EventCallBack (card, 1, DBEvent, signal_handler);
    D2K_AI_EventCallBack (card, 1, DAQEnd, signal_handler2);
#endif	
    D2K_AI_EventCallBackEx (card, 1, DBEvent, dbevt_handler, (void* ) &param);
    D2K_AI_EventCallBackEx (card, 1, DAQEnd, evt_handler, (void* ) &param);

    //setup signal handler
    D2K_AO_EventCallBackEx (card, 1, DBEvent, dbdaevt_handler, (void* ) &aoparam);
    D2K_AO_EventCallBackEx (card, 1, DAQEnd, daevt_handler, (void* ) &aoparam);

    err = D2K_AI_ContBufferSetup (card, ai_buf, read_count, &Id);
    if (err!=0) {
       printf("D2K_AI_ContBufferSetup error=%d for the 1st buffer", err);
       return -2;
    }
    D2K_AI_ContBufferSetup (card, ai_buf2, read_count, &Id);
    if (err!=0) {
       printf("D2K_AI_ContBufferSetup error=%d for the 2nd buffer", err);
       return -3;
    }

   err = D2K_AO_ContBufferSetup (card, ao_buf, out_count, &daId);
   if (err != NoError) {
	printf("D2K_AO_ContBufferSetup error=%d for the 1st buffer\n", err);
	D2K_Release_Card(card);
	return -1;
   }

   err = D2K_AO_ContBufferSetup (card, ao_buf2, out_count, &daId);
   if (err != NoError) {
	printf("D2K_AO_ContBufferSetup error=%d for the 2nd buffer\n", err);
	D2K_AO_ContBufferReset (card);
	D2K_Release_Card(card);
	return -1;
    }

    buf_index = 0;
    count = 0;

    if(multi) 
      err = D2K_AI_ContReadMultiChannels (card, channel+1, chans, Id, read_count/(channel+1), samp_intrv, samp_intrv/(channel+1), ASYNCH_OP);
    else
      err = D2K_AI_ContReadMultiChannels (card, channel+1, chans, Id, read_count/(channel+1), samp_intrv, samp_intrv, ASYNCH_OP);
    if (err!=0) {
       printf("D2K_AI_ContScanChannels error=%d", err);
       return -4;
    }

    err = D2K_AO_ContWriteChannel (card, 0, daId, out_count, 1, samp_intrv, samp_intrv, ASYNCH_OP);
    if (err != NoError) {
	printf("D2K_AO_ContWriteChannel error=%d\n", err);
	D2K_AO_ContBufferReset (card);
	D2K_Release_Card(card);
	return -1;
    }

    printf("\n\nPress any key to stop input operation.\n");
//    printf("\n\nData count : \n");

    getch();

    err = D2K_AI_AsyncClear(card, &startPos, &count1);
    if( err != 0 ){
	printf("D2K_AI_AsyncClear Failed !!!, Ready to system hang !!!\n" );
	getch();
    }

    err = D2K_AO_AsyncClear(card, &dacount1, 0);
    if( err != 0 ){
	printf("D2K_AO_AsyncClear Failed !!!, Ready to system hang !!!\n" );
	getch();
    }

    printf("\n\nPress any key to clear.\n");
    getch();
    //clear signal handler
    D2K_AI_EventCallBackEx (card, 0, DBEvent, NULL, NULL);
    D2K_AI_EventCallBackEx (card, 0, DAQEnd, NULL, NULL);

    D2K_AO_EventCallBackEx (card, 0, DBEvent, NULL, NULL);
    D2K_AO_EventCallBackEx (card, 0, DAQEnd, NULL, NULL);
 
    D2K_Release_Card(card);

    fclose( fp );
    printf("\n\n%ld input data are stored in file '%s'.\n", count, file_name);

    putchar('\n');
    return 0;
}

void write_buffer_to_file( void )
{
  U32 XferCnt = 0;
  U16 *actPtr;
  char s[50], temp_s[10];
  U32 i;
  int j;
  int chan_no = channel +1;
  
  XferCnt = read_count;
  actPtr = actBuf? ai_buf2: ai_buf;    	
  for(i=0; i< XferCnt; i+=chan_no){
    s[0] = 0x00;
    for( j = 0; j < chan_no; j++ ){
  	sprintf( temp_s, "%x  ", actPtr[i+j] );
        strcat( s, temp_s );
    }
    strcat(s, "\n");
    fwrite(s, sizeof(U8), strlen(s), fp);
  }
}

