#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <pthread.h>
#include <sys/mman.h>
#include <conio.h>
#include "d2kdask.h"

U16 channel = 3;  //4 channels
U16 chans[4]={0,1,2,3};
U16 range = AD_B_10_V;
char file_name[20] = "dmaData.txt";
U32 read_count = 48000;
U32 samp_intrv = 4000;
unsigned short ai_buf[48000];
unsigned short ai_buf2[48000];
pthread_t pthread;
BOOLEAN clear_op;
I16 card = -1, multi = 0;
U32 count = 0, t=0;
U16 actBuf = 0;
FILE* fp;

void write_buffer_to_file( void );

void signal_handler(int sig_no)
{
     BOOLEAN halfReady, fStop;
     U16 sts=0;

     D2K_AI_AsyncDblBufferHalfReady(card, &halfReady, &fStop);
     write_buffer_to_file();
     D2K_AI_AsyncDblBufferHandled(card);     
     actBuf = (actBuf+1)%2;
     count += (read_count);
     D2K_AI_AsyncDblBufferOverrun(card, 0, &sts); //checking overrun status
     if(sts) {//ovrerrun is happened
              t++;
              D2K_AI_AsyncDblBufferOverrun(card, 1, &sts); //clear overrun flag
             }
     printf("\roverrun:%d, count: %d", t, count);
}

void signal_handler2(int sig_no)
{
     printf("\nfinish\n");
}

#define CardNum   12

U16 CardType[CardNum] = {DAQ_2005, DAQ_2006, DAQ_2010, DAQ_2016, DAQ_2204, DAQ_2205, DAQ_2206, DAQ_2208, DAQ_2213, DAQ_2214, DAQ_2501, DAQ_2502};

int main( void )
{
    I16 err, Id;
    int card_num = 0, card_type = DAQ_2010;
    U32 count1, startPos;

    setbuf( stdout, NULL );
    clrscr();
    
    printf("This program inputs data from CH-0 to CH-%d of DAQ-2000#%d in %d Hz by\ndouble-buffer mode, and store data to file '%s'. The size of circular\nbuffer is %ld. It will not stop until you press a key.\n\n",
           channel, card_num, 1000, file_name, read_count);
    printf("--------------------------------------------\n");
    printf("0. DAQ-2005\n1. DAQ-2006\n2. DAQ-2010\n3. DAQ-2016\n4. DAQ-2204\n5. DAQ-2205\n6. DAQ-2206\n7. DAQ-2208\n8. DAQ-2213\n9. DAQ-2214\n10. DAQ-2501\n11. DAQ-2502\n");
    printf("--------------------------------------------\n");
    printf("Please select a card type: ");
    scanf(" %d", &card_type);
    if(card_type>2)
        multi = 1;
    else
        multi = 0;
    card_type = CardType[card_type];

    printf("Please input a card number: ");
    scanf(" %i", &card_num);
    if( (fp = fopen( file_name, "w+b" ) ) == NULL )
	return -10;
    fprintf( fp, " ContScanChannels with Double Buffer Transfer \n\n\n");
    fprintf( fp, "CH0   CH1   CH2   CH3 \n======================\n");
    if ((card=D2K_Register_Card (card_type, (I16)card_num)) <0 ) {
        printf("Register_Card error=%d\n", card);
        return -1;
    }
    D2K_AI_CH_Config (card, -1, range);
    err = D2K_AI_Config (card, 0, DAQ2K_AI_TRGMOD_POST|DAQ2K_AI_TrgPositive, 0, 0, 0,1);
    if (err!=0) {
       printf("D2K_AI_Config error=%d", err);
       exit(1);
    }
    err = D2K_AI_AsyncDblBufferMode (card, 1);
    if (err!=0) {
       printf("DAQ2K_AI_DblBufferMode error=%d", err);
       return -3;
    }
    //setup signal handler
    D2K_AI_EventCallBack (card, 1, DBEvent, signal_handler);
    D2K_AI_EventCallBack (card, 1, DAQEnd, signal_handler2);
	
    err = D2K_AI_ContBufferSetup (card, ai_buf, read_count, &Id);
    if (err!=0) {
       printf("D2K_AI_ContBufferSetup error=%d for the 1st buffer", err);
       return -2;
    }
    D2K_AI_ContBufferSetup (card, ai_buf2, read_count, &Id);
    if (err!=0) {
       printf("D2K_AI_ContBufferSetup error=%d for the 2nd buffer", err);
       return -3;
    }
    if(multi) 
      err = D2K_AI_ContReadMultiChannels (card, channel+1, chans, Id, read_count/(channel+1), samp_intrv, samp_intrv/(channel+1), ASYNCH_OP);
    else
      err = D2K_AI_ContReadMultiChannels (card, channel+1, chans, Id, read_count/(channel+1), samp_intrv, samp_intrv, ASYNCH_OP);
    if (err!=0) {
       printf("D2K_AI_ContScanChannels error=%d", err);
       return -4;
    }
    printf("\n\nPress any key to stop input operation.");
    printf("\n\nData count : \n");

    getch();

    err = D2K_AI_AsyncClear(card, &startPos, &count1);
    if( err != 0 ){
	printf("D2K_AI_AsyncClear Failed !!!, Ready to system hang !!!\n" );
	getch();
    }
    //clear signal handler
    D2K_AI_EventCallBack (card, 0, DBEvent, NULL);
    D2K_AI_EventCallBack (card, 0, DAQEnd, NULL);
 
    D2K_Release_Card(card);

    fclose( fp );
    printf("\n\n%ld input data are stored in file '%s'.\n", count, file_name);

    putchar('\n');
    return 0;
}

void write_buffer_to_file( void )
{
  U32 XferCnt = 0;
  U16 *actPtr;
  char s[50], temp_s[10];
  U32 i;
  int j;
  int chan_no = channel +1;
  
  XferCnt = read_count;
  actPtr = actBuf? ai_buf2: ai_buf;    	
  for(i=0; i< XferCnt; i+=chan_no){
    s[0] = 0x00;
    for( j = 0; j < chan_no; j++ ){
  	sprintf( temp_s, "%x  ", actPtr[i+j] );
        strcat( s, temp_s );
    }
    strcat(s, "\n");
    fwrite(s, sizeof(U8), strlen(s), fp);
  }
}

