#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys/time.h>
#include <unistd.h>
#include "conio.h"
#include "d2kdask.h"

#define CHANNELNUMBER 0
#define AIRANGE       AD_B_10_V
#define BASETIME      40000000
#define SCANCOUNT     10000
#define ADCONVERTSRC  DAQ2K_AI_ADCONVSRC_Int
#define ADTRIGSRC     DAQ2K_AI_TRGSRC_ExtD
#define ADTRIGMODE    DAQ2K_AI_TRGMOD_POST
#define ADTRIGPOL     DAQ2K_AI_TrgPositive
#define ReTrigCOUNT	   0
#define BUFAUTORESET   1
#define SCAN_INTERVAL  400
#define POSTCOUNT      0

#define CardNum   12

U16 CardType[CardNum] = {DAQ_2005, DAQ_2006, DAQ_2010, DAQ_2016, DAQ_2204, DAQ_2205, DAQ_2206, DAQ_2208, DAQ_2213, DAQ_2214, DAQ_2501, DAQ_2502};

I16 card = -1;
short ai_buf[10000];
short ai_buf2[10000];
U32 count=0, startPos=0, times=0;

struct timeval tv_start, tv_end;
struct timezone tz;

#pragma pack(push,1)

typedef struct _D2K_MODULE_PARAM
{
		short	card_number;			
		short	card_type;	
		unsigned short ch;
		unsigned long   scancount;
		unsigned long   scan_interval;
}
D2K_MODULE_PARAM;

#pragma pack(pop)

D2K_MODULE_PARAM param;

void show_channel_data(U16 *buf, U32 count, U16 startPos);

void trgevt_handler(int type, void* arg)
{  
     BOOLEAN trigready, fStop=0;
     U16 RdyTrigCnt=0;
     I16 err=0;
  
 gettimeofday( &tv_end, &tz );
   printf("trg: evt_%hd|cardtype_%hd|cardid_%hd\n", type, ((D2K_MODULE_PARAM *) arg)->card_type, ((D2K_MODULE_PARAM *) arg)->card_number);
   printf("trg time for DMA operation is: %ld.%06ld sec\n", tv_end.tv_sec, tv_end.tv_usec);
    err = D2K_AI_AsyncReTrigNextReady (card, &trigready, &fStop,&RdyTrigCnt); 
    if(trigready){ 
                //if(RdyTrigCnt!=(times%2))
		printf("ready buffer index: %d\n",RdyTrigCnt);      
                times += 1;
     }
}

void evt_handler(int type, void* arg)
{  

    printf("\nfinish\n");

}

int main( void )
{
    I16 err, Id; 
    int card_num, card_type=DAQ_2010;

    setbuf( stdout, NULL );
    clrscr();

    tz.tz_minuteswest = 0;
    tz.tz_dsttime = 0;

    printf("This program inputs %d scans from CH-0 in %d Hz.\n", SCANCOUNT, (int)(BASETIME/SCAN_INTERVAL));
    printf("--------------------------------------------\n");
    printf("0. DAQ-2005\n1. DAQ-2006\n2. DAQ-2010\n3. DAQ-2016\n4. DAQ-2204\n5. DAQ-2205\n6. DAQ-2206\n7. DAQ-2208\n8. DAQ-2213\n9. DAQ-2214\n10. DAQ-2501\n11. DAQ-2502\n");
    printf("--------------------------------------------\n");
    printf("Please select a card type: ");
    scanf(" %d", &card_type);
    card_type = CardType[card_type];
    printf("Please input a card number: ");
    scanf(" %d", &card_num);
    if ((card=D2K_Register_Card (card_type, (I16)card_num)) <0 ) {
			printf("Register_Card error=%d", card);
			return -1;
    }
    err = D2K_AI_CH_Config (card, CHANNELNUMBER, AIRANGE);
    if (err != NoError) {
			printf("D2K_AI_CH_Config error=%d", err);
			D2K_Release_Card(card);
			return -1;
    }
	//set callback param
	param.card_number=card;
	param.card_type=card_type;
	param.ch=CHANNELNUMBER;
	param.scan_interval=SCAN_INTERVAL;
	param.scancount=SCANCOUNT;

    //err = D2K_AIO_Config (card, DAQ2K_IntTimeBase, Above_High_Level|EXTATRIG, 0x80, 0x80);
    err = D2K_AI_Config (card, ADCONVERTSRC, ADTRIGSRC|ADTRIGMODE|DAQ2K_AI_ReTrigEn, POSTCOUNT, 0, ReTrigCOUNT, BUFAUTORESET);
    if (err != NoError) {
			printf("D2K_AI_Config error=%d", err);
			D2K_Release_Card(card);
			return -1;
    }

    err=D2K_AI_ContBufferSetup (card, ai_buf, SCANCOUNT,&Id);
    if (err != NoError) {
			printf("D2K_AI_ContBufferSetup error=%d", err);
			D2K_Release_Card(card);
			return -1;
    }
    D2K_AI_EventCallBackEx (card, 1, TrigEvent, trgevt_handler, (void* ) &param);
    D2K_AI_EventCallBackEx (card, 1, DAQEnd, evt_handler, (void* ) &param);

    err=D2K_AI_ContBufferSetup (card, ai_buf2, SCANCOUNT, &Id);
    if (err!=0) {
       printf("D2K_AI_ContBufferSetup2 error=%d", err);
       exit(1);
    }

    printf("\n\n\nStart Data Conversion by External Analog Trigger Signal.\nThe times of Re-TRIGGER is %d.\n", ReTrigCOUNT);
    gettimeofday( &tv_start, &tz );
    printf(" Start time for DMA operation is: %ld.%06ld sec\n", tv_start.tv_sec, tv_start.tv_usec);

    err = D2K_AI_ContReadChannel (card, CHANNELNUMBER, Id, SCANCOUNT, SCAN_INTERVAL, SCAN_INTERVAL, ASYNCH_OP);
    if (err != NoError) {
			printf("D2K_AI_ContReadChannel error=%d", err);
			D2K_AI_ContBufferReset(card);
			D2K_Release_Card(card);
			return -1;
    }
#if 0
    do {       
        err = D2K_AI_AsyncReTrigNextReady (card, &trigready, &fStop,&RdyTrigCnt); 
  	if(trigready){ 
                //if(RdyTrigCnt!=(times%2))
		printf("ready buffer index: %d\n",RdyTrigCnt);      
                times += 1;
        }
    } while(!kb_hit());
#endif
    printf("\n\nPress any key to stop input operation.");
    getch();
    D2K_AI_AsyncClear(card, &startPos, &count);
    //Here to handle the data stored in ready buffer
    printf("\n\nTotal %ld input data.\n", count+SCANCOUNT*times);
    printf("\n\nPress any key to show data.\n");
    getch();
    //clear signal handler
    D2K_AI_EventCallBackEx (card, 0, TrigEvent, NULL, NULL);
    D2K_AI_EventCallBackEx (card, 0, DAQEnd, NULL, NULL);
    show_channel_data(ai_buf, SCANCOUNT, startPos);
    D2K_Release_Card(card);
    printf("\nPress ENTER to exit the program. "); getchar();

    return 0;
}

void show_channel_data( U16 *buf, U32 count, U16 startPos)
{
    int k;
    U32 i;
    F64 voltage;

    printf(" >>>>>>>>>>>>>>> the first 100 valid scans  <<<<<<<<<<<<<<< \n");
    printf("CH0 :\n");
    for (k=0; k<(count/80) && k<10; k++) {
	for( i=k*80; i<(k*80+80) ; i++ ){
            D2K_AI_VoltScale (card, AIRANGE, ai_buf[i], &voltage);
	    printf(" 0x%04x(%+4.2fV)  ", \
		ai_buf[(i+startPos)%SCANCOUNT]&0xffff, voltage);
	    if(i && ((i%4)==3))
		printf("\n");
	}
	if(k<(count/80-1) && k<9) {
	    printf("Press any key for the continued data...\n");
	    getch();
	}
    }
}
