#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys/time.h>
#include "conio.h"
#include "d2kdask.h"
// necessary header file for POSIX signal
//#include <signal.h>

///////////////////////////////////////////////////////////////////////////////
#define PI        3.14159
#define CardNum   8

I16 AO_buf[8192];
U32 data_size = 8192;
U16 CardType[CardNum] = {DAQ_2005, DAQ_2006, DAQ_2010, DAQ_2016, DAQ_2204, DAQ_2205, DAQ_2206, DAQ_2214};

struct timeval tv_start, tv_end;
struct timezone tz;

void signal_handler(int sig_no)
{
   gettimeofday( &tv_end, &tz );
   printf(" End time for DMA operation is: %ld.%06ld sec\n", tv_end.tv_sec, tv_end.tv_usec);

   printf(" Press any key to end data output \n" );
}

int main(int argc, char* argv[])
{
   I16 card = -1, err, i;
   int card_num, card_type;
   U32 count;
   U16 DaId;
//   struct timezone tz;

   tz.tz_minuteswest = 0;
   tz.tz_dsttime = 0;
   setbuf( stdout, NULL );
   clrscr();

   printf("This program outputs data from AO CH-0 in %d Hz.\nThe size of buffer is %ld. The iteration is 2.\n\nPress any key to start the operation.\n\n",
           100000, data_size);
   printf("--------------------------------------------\n");
   printf("0. DAQ-2005\n1. DAQ-2006\n2. DAQ-2010\n3. DAQ-2016\n4. DAQ-2204\n5. DAQ-2205\n6. DAQ-2206\n7. DAQ-2214\n");
   printf("--------------------------------------------\n");
   printf("Please select a card type: ");
   scanf(" %d", &card_type);
   card_type = CardType[card_type];
   printf("Please input a card number: ");
   scanf(" %d", &card_num);
   if((card = D2K_Register_Card(card_type, card_num))<0) {
	printf("Error %d trying to open device\n", card);
	return -1;
   }
   for(i=0; i<8192; i++)
	AO_buf[i]=(I16)(sin((double)i/512*PI)*0x7ff)+0x800;

   err = D2K_AO_CH_Config (card, 0, DAQ2K_DA_BiPolar, DAQ2K_DA_Int_REF, 10.0);
   if(err!=NoError){
	printf("D2K_AO_CH_Config Error %d \n", err);
	D2K_Release_Card(card);
	return -1;
   }
   err = D2K_AO_Config (card, 0, 0, 0, 0, 0,1);
   if(err!=NoError){
	printf("D2K_AO_Config Error %d \n", err);
	D2K_Release_Card(card);
	return -1;
   }
   err = D2K_AO_ContBufferSetup (card, AO_buf, data_size, &DaId);
   if(err!=NoError){
	printf("D2K_AO_ContBufferSetup Error %d \n", err);
	D2K_Release_Card(card);
	return -1;
   }
   // setup signal handler
   D2K_AO_EventCallBack (card, 1, DAQEnd, signal_handler); 
    gettimeofday( &tv_start, &tz );
    printf(" Start time for DMA operation is: %ld.%06ld sec\n", tv_start.tv_sec, tv_start.tv_usec);

   err = D2K_AO_ContWriteChannel (card, 0, DaId, data_size, 2, 400, 1, ASYNCH_OP);
   if(err!=NoError){
	printf("D2K_AO_ContWriteChannel Error %d \n", err);
	D2K_AO_ContBufferReset (card);
	D2K_Release_Card(card);
	return -1;
   }
   getch();
   D2K_AO_AsyncClear(card, &count, 2);
   //reset signal
   D2K_AO_EventCallBack (card, 0, DAQEnd, NULL);
   D2K_Release_Card(card);
   return 0;
}// main
