#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "conio.h"
#include "d2kdask.h"

#define PI  3.14159
#define CardNum   8
#define out_count 4096

U16 channel=0;
U32 samp_intrv = 40;
U16 ao_buf[out_count];
U16 CardType[CardNum] = {DAQ_2005, DAQ_2006, DAQ_2010, DAQ_2016, DAQ_2204, DAQ_2205, DAQ_2206, DAQ_2214};
U32 count=0, trgcnt=0;

void signal_handler(int sig_no)
{
    trgcnt++;
    printf("trigger cnt: %ld\r", trgcnt);
}

void signal_handler2(int sig_no)
{
     printf("\nfinish\n");
}

int main( void )
{
   I16 card, err, i, Id;
   int card_num, card_type;
   U32 count1;

   setbuf( stdout, NULL );
   clrscr();

   printf("This program demonstrates Infinite re-trigger DA\n\n");
   printf("--------------------------------------------\n");
   printf("0. DAQ-2005\n1. DAQ-2006\n2. DAQ-2010\n3. DAQ-2016\n4. DAQ-2204\n5. DAQ-2205\n6. DAQ-2206\n7. DAQ-2214\n");
   printf("--------------------------------------------\n");
   printf("Please select a card type: ");
   scanf(" %d", &card_type);
   card_type = CardType[card_type];
   printf("Please input a card number: ");
   scanf(" %d", &card_num);
   //getch();
   if ((card=D2K_Register_Card (card_type, card_num)) <0 ) {
        printf("Register_Card error=%d\n", card);
        exit(1);
   }

   for (i=0;i<out_count;i++) 
	ao_buf[i] = (I16)(sin((double)i/512*PI)*0x7ff)+0x800;

   err = D2K_AO_CH_Config (card, 0, DAQ2K_DA_BiPolar, DAQ2K_DA_Int_REF, 10.0);
   if (err != NoError) {
	printf("D2K_AO_CH_Config error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
   }

   err = D2K_AO_Config (card, 0, DAQ2K_DA_TRGMOD_POST|DAQ2K_DA_TRGSRC_ExtD|DAQ2K_DA_TrgPositive|DAQ2K_DA_ReTrigEn, 0, 0, 0,1);
   if (err != NoError) {
	printf("D2K_AO_Config error=%d\n", err);
	D2K_Release_Card(card);
	return -1;
   }
   //setup signal handler
   D2K_AO_EventCallBack (card, 1, DATrigEvent, signal_handler);
   D2K_AO_EventCallBack (card, 1, DAQEnd, signal_handler2);
   err = D2K_AO_ContBufferSetup (card, ao_buf, out_count, &Id);
   if (err != NoError) {
	printf("D2K_AO_ContBufferSetup error=%d for the 1st buffer\n", err);
	D2K_Release_Card(card);
	return -1;
   }
    trgcnt = 0;
    count = 0;

    err = D2K_AO_ContWriteChannel (card, 0, Id, out_count, 2, samp_intrv, samp_intrv, ASYNCH_OP);
    if (err != NoError) {
	printf("D2K_AO_ContWriteChannel error=%d\n", err);
	D2K_AO_ContBufferReset (card);
	D2K_Release_Card(card);
	return -1;
    }
    printf("\n\nPress any key to stop input operation.");
    printf("\n\nData count : \n");

    getch();
    D2K_AO_AsyncClear(card, &count1, 1);
    usleep(1000);
    //clear signal setup
    D2K_AO_EventCallBack (card, 0, DATrigEvent, NULL);
    D2K_AO_EventCallBack (card, 0, DAQEnd, NULL);

    D2K_Release_Card(card);
    puts("\nPress ENTER to exit the program. "); getchar();

    return 0;
}
